#ifndef __STDAFX_H__
#define __STDAFX_H__

#include <windows.h>


#ifndef GL_RGB5_A1
#define GL_RGB5_A1 0x8057
#endif
#ifndef GL_UNSIGNED_SHORT_5_5_5_1
#define GL_UNSIGNED_SHORT_5_5_5_1 0x8034
#endif
#ifndef GL_UNSIGNED_SHORT_1_5_5_5_REV
#define GL_UNSIGNED_SHORT_1_5_5_5_REV 0x8366
#endif
#ifndef GL_UNSIGNED_SHORT_5_6_5
#define GL_UNSIGNED_SHORT_5_6_5 0x8363
#endif



// Scanline renderers
//
extern "C" void __stdcall bg_line_text_bottom(void);
extern "C" void __stdcall bg_line_rs_bottom(void);
extern "C" void __stdcall extbg_line_256_bottom(void);
extern "C" void __stdcall extbg_line_256_trans(void);
extern "C" void __stdcall extbg_line_256_ablend(void);
extern "C" void __stdcall extbg_line_dc_bottom(void);
extern "C" void __stdcall extbg_line_dc_trans(void);
extern "C" void __stdcall extbg_line_dc_ablend(void);
extern "C" void __stdcall extbg_line_dc_bottom_bgr2rgb_d3d(void);
extern "C" void __stdcall extbg_line_dc_bottom_bgr2rgb_ogl(void);
extern "C" void __stdcall extbg_line_dc_trans_bgr2rgb_d3d(void);
extern "C" void __stdcall extbg_line_dc_trans_bgr2rgb_ogl(void);
extern "C" void __stdcall extbg_line_dc_ablend_bgr2rgb_d3d(void);
extern "C" void __stdcall extbg_line_dc_ablend_bgr2rgb_ogl(void);
extern "C" void __stdcall extbg_line_rs_bottom(void);
extern "C" void __stdcall extbg_line_rs_trans(void);
extern "C" void __stdcall extbg_line_rs_ablend(void);
extern "C" void __stdcall extbg_line_rs_bottom_bgr2rgb_d3d(void);
extern "C" void __stdcall extbg_line_rs_bottom_bgr2rgb_ogl(void);
extern "C" void __stdcall extbg_line_rs_trans_bgr2rgb_d3d(void);
extern "C" void __stdcall extbg_line_rs_trans_bgr2rgb_ogl(void);
extern "C" void __stdcall extbg_line_rs_ablend_bgr2rgb_d3d(void);
extern "C" void __stdcall extbg_line_rs_ablend_bgr2rgb_ogl(void);
extern "C" void __stdcall mode6_line(void);
extern "C" void __stdcall obj_line(void);



extern "C" unsigned char *VRAM,*VRAM_curr,*vscreen,*currPalette,*vscreen_curr,*patternTbl;
extern "C" unsigned char *charBank,*screenBank;
extern unsigned char	*VRAM_A,*VRAM_B,*VRAM_C,*VRAM_D,*VRAM_E,*VRAM_F,*VRAM_G,*VRAM_H,*VRAM_I;
extern unsigned char	*vscreen2,*vscreen3,*vscreenmem,*IOREGS,*IOREGS_ARM7;
extern unsigned char	*VRAM_s,*VRAM_lcdc,*vscreen_s,*vscreen2_s;
extern unsigned char	*framebuffer;
extern "C" unsigned char *io_base,*oam_base,*pal_base;
extern "C" DWORD		vscreen_size;
extern "C" short int	bgcnt;
extern "C" unsigned int useExtPltt;
extern "C" int			lineaddr;
extern "C" int			scrBase,chrBase;
extern "C" int			glFormat,glFormatBackup;
extern "C" int			scanline;
extern "C" int			spriteCnt,spriteLimit,spriteTile,spriteBit6,prio_int,cmTileShift,tileData;
extern "C" int			xtile;
extern "C" unsigned int hTileMask,vTileMask,hScrMask,hScrShift,vScrMask,vScrShift,tileShift;
extern "C" unsigned int hofs,vofs;
extern "C" unsigned int mstrChar,mstrScrn;

extern short int		palfx[4][256];
extern int				lumachange,eva,evb,blended,blended2;
extern "C" int			evy,numBlends,ablend;
extern "C" unsigned int	objLuma;

extern bool				hasMMX,hasSSE,hasSSE2,hasCMOV;
extern "C" bool			useGL,useD3D;
extern bool				glOK,glIsInit;
extern bool				d3dOK,d3dIsInit;
extern bool				isFlipped[4],didLumaOp;
extern bool				logIRQ;


extern "C" unsigned short int alphamap[256];
extern unsigned short int		*p_alphamap,*p_alphamap_int;
extern __declspec(align(16)) __int64 EVA128[2];
extern __declspec(align(16)) __int64 EVB128[2];
extern __declspec(align(16)) __int64 MASKBLUE[2];
extern __declspec(align(16)) __int64 MASKGREEN[2];
extern __declspec(align(16)) __int64 MASKRED[2];
extern __declspec(align(16)) __int64 SHAMT1[2];
extern __declspec(align(16)) __int64 SHAMT2[2];
extern __declspec(align(16)) __int64 SHAMT3[2];
extern __declspec(align(16)) __int64 SHAMT4[2];
extern __declspec(align(16)) __int64 SHAMT5[2];
extern __declspec(align(16)) __int64 SHAMT6[2];

extern __declspec(align(16)) __int64 MASKHALF[2];
extern __declspec(align(16)) __int64 MASK50[2];
extern __declspec(align(16)) __int64 ALPHAON[2];

#endif

