// Dualis
// (c) Mic 2007
//
// Functions and data are scattered all over the place. Have fun..

#define _CRT_SECURE_NO_DEPRECATE 1

// Windows Header Files:
#include <windows.h>
#include <windowsx.h>
#include <commctrl.h>
#include <winuser.h>

// C RunTime Header Files
#include <stdlib.h>
#include <stdio.h>
#include <malloc.h>
#include <memory.h>
#include <tchar.h>

#include "CEventQueue.h"
#include "CMenu.h"
#include "CScrollBar.h"

#include "avigenerator.h"
#include "dialogs.h"
#include "dualis.h"
#include "tabs.h"
#include "beeampee.h"
#include "resource.h"
#include "zombie.h"
#include "disarm.h"
#include "ndsfile.h"
#include "mspal.h"
#include "ioregs.h"
#include "ipc.h"
#include "unzip.h"
#include "7z\C\7zip\Archive\7z_C\7zCrc.h"
//#include "7z\C\7zip\Archive\7z_C\7zIn.h"
#include "7z\C\7zip\Archive\7z_C\7zExtract.h"


// Menuitem enumerators
#define IDM_ROM_INFO					1003
#define IDM_CLOSE						1004
#define IDM_SCREENSHOT					1005
#define IDM_EXIT						1012

#define IDM_RUN							1101
#define IDM_PAUSE						1102
#define IDM_RESET						1103

#define IDM_ABOUT						1301

#define IDM_RECENT1                     40040
#define IDM_RECENT2                     40041
#define IDM_RECENT3                     40042
#define IDM_RECENT4                     40043
#define IDM_RECENT5                     40044
#define IDM_RECENT6                     40045
#define IDM_RECENT7                     40046
#define IDM_RECENT8                     40047

#define IDC_MAINSCR						1901
#define IDC_SUBSCR						1902

#define IDC_MEMCOMBO					1950


#define FRAMES_PER_SECOND	60.0f


#define WINERROR(message) wsprintf(szBuffer,"%s\nError code = %08X.",message,GetLastError()); \
	                      MessageBox(NULL,szBuffer,"Error",MB_ICONERROR)

#define COMMDLGERROR(message) wsprintf(szBuffer,"%s\nError code = %08X.",message,CommDlgExtendedError()); \
	                      MessageBox(NULL,szBuffer,"Error",MB_ICONERROR)

#define WINPRINT(fmtstr,val) wsprintf(szBuffer,fmtstr,val); \
	                         WriteConsole(hOut,szBuffer,lstrlen(szBuffer),&dwDummy,NULL)

#define WINPRINTBOX(fmtstr,val) wsprintf(szBuffer,fmtstr,val); \
	                         MessageBox(NULL,szBuffer,"Info",MB_ICONINFORMATION)


// For 7z
typedef struct _CFileInStream {
  ISzInStream InStream;
  FILE *File;
} CFileInStream;


// Data galore..

int __stdcall hub(int,int,void*,void*);
void add_recent_file(char*);

LRESULT CALLBACK page1_dlgproc(HWND,UINT,WPARAM,LPARAM);
LRESULT CALLBACK page2_dlgproc(HWND,UINT,WPARAM,LPARAM);
LRESULT CALLBACK page3_dlgproc(HWND,UINT,WPARAM,LPARAM);
LRESULT CALLBACK page4_dlgproc(HWND,UINT,WPARAM,LPARAM);

unsigned int	arm9PluginVersion,arm7PluginVersion,mmuPluginVersion,
				gpuPluginVersion,inpPluginVersion,apuPluginVersion,
				guiVersion=33;


HWND			hMain,hPropsheet,hMainChk,hSubChk,hMainScr,hSubScr,hStatus,hPalw,hDbgw,hMemw;
HWND			hScrollbar1,hScrollbar2,hComboMem;
HDC				paldc,dbgdc,memdc,disdc,iodc,twdc,mapdc,oamdc,texdc,matdc;
HFONT			font;
HANDLE			hOut;
HINSTANCE		hInst=NULL,hCPU,hCPUsub,hMMU,hGPU,hAPU,hINP;
HACCEL			haccel;
PAINTSTRUCT		ps;
MSG				msg;
UINT			defaultFontID;

unsigned int	*arm9_regs,*arm7_regs;
char			**pageTable,**arm7_pageTable;
unsigned int	arm9_pageMask[256],arm7_pageMask[256];
char			vPath[256],*szPath,currDir[256],szRomPath[256];
int				mirrorIPC = 1;
NDSFileHeader	hdr;
MSPAL			mspal;
char			szStat0[256],szStat1[256];
int				keymap[32];

char			dbgMessages[32][64];
int				dbgMsgCount=0;
int				dbgMsgPos=0,memVPos=0x00800000; 
SCROLLINFO		si,si2,si3,si4;
CScrollBar		memviewScroll,disasmScroll,debugScroll;
COLORREF		colors[8];
unsigned int	memview_lut[13] = {0x00000000,0x00800000,0x02000000,0x02004000,
                                   0x04000000,0x04001000,0x05000000,0x05000400,
								   0x06000000,0x06200000,
					  		       0x06800000,0x07000000,0x08000000};
palette_dib		*pdib;
int				palUpdateMode=1;

DLGPROC			PageDlgProc[4] = {(DLGPROC)page1_dlgproc,(DLGPROC)page2_dlgproc,
							   	(DLGPROC)page3_dlgproc,(DLGPROC)page4_dlgproc,};
CMenu			*menu;
CPopup			*recentFilesMenu;
char			recentFiles[8][MAX_PATH+1];

OPENFILENAME	ofName;
window			windows[NUM_WINDOWS];
RECT			rect2;

CEventQueue		*eq;

LARGE_INTEGER	perfCnt1,perfCnt2,perfFreq;

DWORD			dwDummy,dwTimerOf;

char			szBuffer[512],szFnBuffer[400],szBuffer3[256];
char			szFileNameOnly[400];

touchpad		touch;

char			szPropsheetCaption[5][16] = {"CPU         ","Memory      ",
						                     "Video       ","Audio       ",
						    			     "Input       "};
int				propSheetButtons[] = {IDOK, IDCANCEL, 0x3021, IDHELP};

cpu_init_callback cpu_init;
cpu_reset_callback cpu_reset;
cpu_get_callback cpu_get;
cpu_set_callback cpu_set;
cpu_execute_until_callback cpu_execute_until;

// For ARM7
cpu_init_callback cpu_sub_init;
cpu_reset_callback cpu_sub_reset;
cpu_get_callback cpu_sub_get;
cpu_set_callback cpu_sub_set;
cpu_execute_until_callback cpu_sub_execute_until;

mmu_init_callback mmu_init;
mmu_reset_callback mmu_reset;
mmu_get_callback mmu_get;
mmu_set_callback mmu_set;
mmu_close_callback mmu_close;
mmu_read_word_callback mmu_read_word;
mmu_read_dword_callback mmu_read_dword;
mmu_write_byte_callback mmu_write_byte;
mmu_write_word_callback mmu_write_word;
mmu_write_dword_callback mmu_write_dword;

// For ARM7
mmu_read_word_callback mmu_sub_read_word;
mmu_read_dword_callback mmu_sub_read_dword;
mmu_write_byte_callback mmu_sub_write_byte;
mmu_write_word_callback mmu_sub_write_word;
mmu_write_dword_callback mmu_sub_write_dword;

gpu_init_callback	gpu_init;
gpu_reset_callback	gpu_reset;
gpu_get_callback	gpu_get;
gpu_set_callback	gpu_set;
gpu_hblank_callback gpu_hblank;
gpu_advance_line_callback gpu_advance_line;
gpu_close_callback	gpu_close;

mmu_init_callback	inp_init;
mmu_reset_callback	inp_reset;
mmu_get_callback	inp_get;
mmu_set_callback	inp_set;
mmu_close_callback	inp_close;

apu_init_callback	apu_init;
apu_reset_callback	apu_reset;
apu_get_callback	apu_get;
apu_set_callback	apu_set;
apu_close_callback	apu_close;
apu_update_callback	apu_update;

UINT			currFps=0;
int				keys[256];
const int		validModes[4][2] = {{320,240},{640,480},{800,600},{1024,768}};
int				displayScreens = 3;
int				fullscreenWidth,fullscreenHeight;
bool			emulate3D = true, isFullscreen = false, osdFps = false;
DEVMODE			originalSettings;
int				touchAreaStart=192;
int				renderer=0,cfDevice;
int				fpsLimit=1,frameskip=0;
bool			run,quit,romLoaded,disAutoUpdate=false,regviewAutoUpdate=false;
float			cpuEmuSpeed;
char			*cart,*cartSub,*gbacart;
UINT			speed,arm7_cycles,cycles,samples,frames,
                visCycles,totCycles,romSize,romSizeSub,gbaCartSize;
int				blockDMA=0;

SYSTEMTIME		systime;
int				ipcLoc=0,ipcFormat=1;
bool			openCon;
bool			compressedROM;
unsigned char	theme = 6;
int				tsCalibX1,tsCalibY1,tsCalibX2,tsCalibY2;
char			iniFn[256];
unsigned short	tileData[64],objPlainData[64*64],objFinalData[128*128];
palette_dib		tile,objPlain,objFinal;


int				soundMasterEnable,largeSoundBuffer,sampleRate;


bool			pendingPause,pendingScreenshot;
int				bmpFrameSelection;
int				screenshots=0;
loaded_bitmap	bmp_framebuf;
char			szScrFn[256];


#define UYVY 0x59565955





void screenshot() {
	framebuffer = (char*)gpu_get(bmpFrameSelection);
	if (framebuffer) {
		wsprintf(szScrFn,"%s\\dualis%02d.bmp",szRomPath,screenshots);
		screenshots++;
		bmp_framebuf.bpp = 24;
		bmp_framebuf.lpbits = framebuffer;
		bmp_framebuf.xdim = 256;
		bmp_framebuf.ydim = (bmpFrameSelection==GPU_FRAMEBUFFER_BGR24) ? 384 : 192;
		bmp_save(szScrFn,&bmp_framebuf,&bmp_framebuf);
	}
}


/****************************** 7z *********************************/

#define kBufferSize 4096
Byte g_Buffer[kBufferSize];

#ifdef _LZMA_IN_CB
SZ_RESULT SzFileReadImp(void *object, void **buffer, size_t maxRequiredSize, size_t *processedSize)
{
  CFileInStream *s = (CFileInStream *)object;
  size_t processedSizeLoc;
  if (maxRequiredSize > kBufferSize)
    maxRequiredSize = kBufferSize;
  processedSizeLoc = fread(g_Buffer, 1, maxRequiredSize, s->File);
  *buffer = g_Buffer;
  if (processedSize != 0)
    *processedSize = processedSizeLoc;
  return SZ_OK;
}

#else

SZ_RESULT SzFileReadImp(void *object, void *buffer, size_t size, size_t *processedSize)
{
  CFileInStream *s = (CFileInStream *)object;
  size_t processedSizeLoc = fread(buffer, 1, size, s->File);
  if (processedSize != 0)
    *processedSize = processedSizeLoc;
  return SZ_OK;
}

#endif

SZ_RESULT SzFileSeekImp(void *object, CFileSize pos)
{
  CFileInStream *s = (CFileInStream *)object;
  int res = fseek(s->File, (long)pos, SEEK_SET);
  if (res == 0)
    return SZ_OK;
  return SZE_FAIL;
}

/*******************************************************************/

UINT c2,c3;
DWORD tSubID;

DWORD WINAPI call_arm7(LPVOID lpParameter) {
	c2 = cpu_sub_execute_until(*(UINT*)lpParameter);
	return 1;
}


void emulate() {
	UINT c1;
	event e;
	unsigned char evType;

	// Send message to the debug console
	hub(TELL,ZOMBIE_DEBUG_MSG,"Beginning emulation",0);

	SendMessage(hStatus,SB_SETTEXT,2,(LPARAM)"Running");
	GetLocalTime(&systime);
	c2 = 0;

	while (run)	{
		// Pull the next event off the queue 
		eq->dequeue(&e);
		evType = e.data&0xFF;
		
		if (romSizeSub) {
			if (((evType!=EV_TIMER_OVERFLOW)&&(evType!=EV_TIMER_COUNTUP)) || ((e.data&0x40000)==0x40000)) {
				c2 = cpu_sub_execute_until(e.timestamp>>1);
				c2 += c2;
			}
		}
		/*if ((e.timestamp-cpu_get(CPU_CYCLE_COUNT)) > 60000000)
		{
			wsprintf(szBuffer,"Very large time delta [%d, %d (%08x), %d, %d]\n",e.timestamp,cpu_get(CPU_CYCLE_COUNT),
				cpu_get(CPU_CYCLE_COUNT),e.data,eq->nItems);
			WriteConsole(hOut,szBuffer,lstrlen(szBuffer),(unsigned long*)&dwDummy,NULL);
		}*/

		if (((evType!=EV_TIMER_OVERFLOW)&&(evType!=EV_TIMER_COUNTUP)) || ((e.data&0x40000)!=0x40000))
			c1 = cpu_execute_until(e.timestamp);


		/*if (romSizeSub)
			mmu_set(MMU_IRQ_CHECK,1,0);
		mmu_set(MMU_IRQ_CHECK,0,0);*/

		// Check the kind of event that occured 
		switch (evType) {
			case EV_TIMER_OVERFLOW:
				mmu_set(MMU_TIMER_OVERFLOW, e.data&0xFF0000, 0);
				cycles = c1;
				arm7_cycles = c2;
				break;
			case EV_TIMER_COUNTUP:
				mmu_set(MMU_TIMER_COUNTUP, e.data&0xFF0000, 0);
				cycles = c1;
				arm7_cycles = c2;
				break;

			case EV_HBLANK_START:
				cycles = c1;
				arm7_cycles = c2;
				gpu_hblank();
				//apu_update();
				break;

			case EV_HBLANK_END:
				//wsprintf(szBuffer,"Blocked %d times\n",blocked);
				//WriteConsole(hOut,szBuffer,lstrlen(szBuffer),(unsigned long*)&dwDummy,NULL);
				gpu_advance_line();
				cycles = c1;
				arm7_cycles = c2;
				//blocked = 0;

				e.timestamp = cycles+visCycles; e.data = EV_HBLANK_START;
				eq->enqueue(&e);
				e.timestamp = cycles+totCycles; e.data = EV_HBLANK_END;
				eq->enqueue(&e);


				/* Process window messages */
				while(PeekMessage(&msg,NULL,0,0,1)) {
					if (!TranslateAccelerator(
							hMain,      // handle to receiving window
							haccel,     // handle to active accelerator table
							&msg))      // message data
					{
						TranslateMessage(&msg);
						DispatchMessage(&msg);
					}
				}


				//break;
		}
	}
}


void emulate_old() {
	LONGLONG t1;
	UINT c1;
	event e;
	//int i;
	static int deblimit=10;
	int blocked = 0;

	// Send message to the debug console
	hub(TELL,ZOMBIE_DEBUG_MSG,"Beginning emulation",0);

	SendMessage(hStatus,SB_SETTEXT,2,(LPARAM)"Running");
	GetLocalTime(&systime);
	c2 = 0;

	while (run)	{
		/* Pull the next event off the queue */
		eq->dequeue(&e);

		//wsprintf(szBuffer,"Event: %08X, %X\n",e.timestamp,e.data);
		//WriteConsole(hOut,szBuffer,lstrlen(szBuffer),(unsigned long*)&dwDummy,NULL);

		/* Execute the number of cycles up till the next event, and measure
		   the time it took to do it. */
		QueryPerformanceCounter(&perfCnt1);
		
		if (romSizeSub) {
			//c3 = e.timestamp>>1;
			//CreateThread(0, 4096, call_arm7, &c3, 0, &tSubID);
			c2 = cpu_sub_execute_until(e.timestamp>>1);
			c2 += c2;
		}
		c1 = cpu_execute_until(e.timestamp);

		QueryPerformanceCounter(&perfCnt2);

		/* Update the current execution speed measure */
		/*t1 = perfCnt2.QuadPart - perfCnt1.QuadPart;
		if (t1>1) {
			cpuEmuSpeed += (float)((c1 - cycles)+((c2-arm7_cycles)>>1)) / (float)t1;
			samples++;
		}*/

		//wsprintf(szBuffer,"c1=%d, tstmp=%d, diff=%d, t1=%d\n",c1,e.timestamp,c1-cycles,t1);
		//WriteConsole(hOut,szBuffer,lstrlen(szBuffer),(unsigned long*)&dwDummy,NULL);

		/* Check the kind of event that occured */
		switch (e.data&0xFF) {
			case EV_TIMER_OVERFLOW:
				mmu_set(MMU_TIMER_OVERFLOW, e.data&0xFF0000, 0);
				cycles = c1;
				arm7_cycles = c2;
				break;
			case EV_TIMER_COUNTUP:
				mmu_set(MMU_TIMER_COUNTUP, e.data&0xFF0000, 0);
				cycles = c1;
				arm7_cycles = c2;
				break;

			case EV_HBLANK_START:
				cycles = c1;
				arm7_cycles = c2;
				gpu_hblank();
				break;

			case EV_HBLANK_END:
				//wsprintf(szBuffer,"Blocked %d times\n",blocked);
				//WriteConsole(hOut,szBuffer,lstrlen(szBuffer),(unsigned long*)&dwDummy,NULL);
				gpu_advance_line();
				cycles = c1;
				arm7_cycles = c2;
				//blocked = 0;

				/* Process window messages */
				while(PeekMessage(&msg,NULL,0,0,1)) {
					if (!TranslateAccelerator(
							hMain,      // handle to receiving window
							haccel,     // handle to active accelerator table
							&msg))      // message data
					{
						TranslateMessage(&msg);
						DispatchMessage(&msg);
					}
				}

				e.timestamp = cycles+visCycles; e.data = EV_HBLANK_START;
				eq->enqueue(&e);
				e.timestamp = cycles+totCycles; e.data = EV_HBLANK_END;
				eq->enqueue(&e);
				break;
		}
	}
}



void reset_machine(bool hard) {
	//float f;
	int totlines,linesize,hbipixels,scale;
	unsigned int i;
	event e;
	static char usrname[]="G.W. Bush";
	static char usrmsg[]="Dubya haqd your ds!";

	//MessageBox(NULL,"Reseting MMU","Debug",MB_OK);

	// Reset MMU plugin
	if ((mmu_reset==NULL) || (!mmu_reset())) {
		hub(TELL,ZOMBIE_DEBUG_MSG,"mmu_reset failed",0);
		WINERROR("mmu_reset failed.");
		gpu_close();
		mmu_close();
		ExitProcess(0);
	}

	//MessageBox(NULL,"Reseting input","Debug",MB_OK);
	// Reset input plugin
	inp_reset();

	//MessageBox(NULL,"Writing personal data","Debug",MB_OK);

	// Personal info ////////////////////////////////
	mmu_write_byte(0x23FFC82, theme);
	mmu_write_byte(0x23FFC83, 7);
	mmu_write_byte(0x23FFC84, 6);

	for (i=0; i<strlen(usrname); i++) {
		mmu_write_byte(0x23FFC86+i+i+1, 0);
		mmu_write_byte(0x23FFC86+i+i, usrname[i]);
	}

	for (i=0; i<strlen(usrmsg); i++) {
		mmu_write_byte(0x23FFC9C+i+i+1, 0);
		mmu_write_byte(0x23FFC9C+i+i, usrmsg[i]);
	}

	mmu_write_byte(0x23FFCD0, strlen(usrmsg));
	mmu_write_byte(0x23FFCD1,0);
	mmu_write_byte(0x23FFC9A,strlen(usrname));
	mmu_write_byte(0x23FFC9B,0);

	mmu_write_word(0x23FFCD8,tsCalibX1);
	mmu_write_word(0x23FFCDA,tsCalibY1);
	mmu_write_byte(0x23FFCDC,0x20);
	mmu_write_byte(0x23FFCDD,0x20);

	mmu_write_word(0x23FFCDE,tsCalibX2);
	mmu_write_word(0x23FFCE0,tsCalibY2);
	mmu_write_byte(0x23FFCE2,256-0x20);
	mmu_write_byte(0x23FFCE3,192-0x20);

	mmu_set(PLUGIN_SETTING, 11, mirrorIPC);
	mmu_set(PLUGIN_SETTING,70,(compressedROM)?0:cfDevice);
	/////////////////////////////////////////////////

	//MessageBox(NULL,"Reseting CPU","Debug",MB_OK);

	// Reset CPU plugins
	cpu_reset();
	cpu_sub_reset();

	//	MessageBox(NULL,"Reseting GPU","Debug",MB_OK);

	// Reset GPU plugin
	gpu_reset();

	//MessageBox(NULL,"Reseting APU","Debug",MB_OK);
	// Reset APU plugin
	apu_reset();
	if (!soundMasterEnable)
		apu_set(APU_PAUSE,1,0);

	//	MessageBox(NULL,"Copying binary","Debug",MB_OK);

	// Copy the ARM9 binary to RAM
	pageTable = (char**)mmu_get(MMU_PAGE_TABLE);
	memcpy(pageTable[hdr.uARM9CopyTo>>20]+(hdr.uARM9CopyTo&arm9_pageMask[hdr.uARM9CopyTo>>20]), cart, romSize);
	wsprintf(szBuffer,"ARM9: Copying %08X bytes to %08X\n",romSize,hdr.uARM9CopyTo);
	WriteConsole(hOut,szBuffer,lstrlen(szBuffer),(unsigned long*)&dwDummy,NULL);

	// Copy the ARM7 binary to RAM
	arm7_pageTable = (char**)mmu_get(MMU_PAGE_TABLE|0x10000);
	if (cartSub) {
		memcpy(arm7_pageTable[hdr.uARM7CopyTo>>20]+(hdr.uARM7CopyTo&arm7_pageMask[hdr.uARM7CopyTo>>20]), cartSub, romSizeSub);
		wsprintf(szBuffer,"ARM7: Copying %08X bytes to %08X\n",romSizeSub,hdr.uARM7CopyTo);
		WriteConsole(hOut,szBuffer,lstrlen(szBuffer),(unsigned long*)&dwDummy,NULL);
		wsprintf(szBuffer,"pt = %08X (%08X), pm = %08X\n",
			arm7_pageTable[hdr.uARM7CopyTo>>20],arm7_pageTable[0x20],arm7_pageMask[hdr.uARM7CopyTo>>20]);

		WriteConsole(hOut,szBuffer,lstrlen(szBuffer),(unsigned long*)&dwDummy,NULL);
	}

	//MessageBox(NULL,"Setting CPU params","Debug",MB_OK);

	speed = cpu_get(CPU_SPEED);
	scale = cpu_get(CPU_CYCLE_SCALING);
	cpu_set(CPU_CYCLE_COUNT,0,0);
	cpu_sub_set(CPU_CYCLE_COUNT,0,0);
	cycles      = cpu_get(CPU_CYCLE_COUNT);
	arm7_cycles = cpu_sub_get(CPU_CYCLE_COUNT);

	wsprintf(szBuffer,"Setting ARM9 reset vector to 0x%08X",hdr.uARM9ExecuteFrom);
	hub(TELL,ZOMBIE_DEBUG_MSG,szBuffer,0);

	//MessageBox(NULL,"Resetting CPU regs","Debug",MB_OK);

	// Reset the program counters
	hub(TELL,CPU_REG_PC,(void*)hdr.uARM9ExecuteFrom,0);
	if (cartSub) {
		wsprintf(szBuffer,"Setting ARM7 reset vector to 0x%08X",hdr.uARM7ExecuteFrom);
		hub(TELL,ZOMBIE_DEBUG_MSG,szBuffer,0);
		hub(TELL,CPU_REG_PC,(void*)hdr.uARM7ExecuteFrom,(void*)1);
	}

	// Scanlines per frame
	totlines = 263;

	// Pixels during hblank
	hbipixels = 99;

	// Pixels per scanline
	linesize = 355;

	// Cycles per scanline (visible part)
	visCycles = 1536 * 2;

	// Cycles per scanline (total)
	totCycles = 2130 * 2;

	//MessageBox(NULL,"Setting up queue","Debug",MB_OK);

	// Flush the event queue
	eq->flush();

	// Initialize the queue
	if (!run) {
		e.timestamp = cycles+visCycles; e.data = EV_HBLANK_START;
		eq->enqueue(&e);
		e.timestamp = cycles+totCycles; e.data = EV_HBLANK_END;
		eq->enqueue(&e);
	}

	disasmScroll.pos = 0x02004000>>2;

	pendingPause = pendingScreenshot = false;

	//MessageBox(NULL,"Done","Debug",MB_OK);

}




// Returns the directory that the program is being executed from
const char *get_path() {
	if (*vPath) return vPath;
	ZeroMemory(vPath, sizeof(vPath));
	GetModuleFileName(hInst, vPath, sizeof(vPath));
	char *p = vPath + lstrlen(vPath);
	while (p >= vPath && *p != '\\') p--;
	if (++p >= vPath) *p = 0;
	return vPath;
}



// Force a desired window size and/or position
void force_window_size(HWND hWnd,int x,int y,int width,int height) {
	RECT rect3;

	GetWindowRect(hWnd,&rect3);
	rect3.right -= rect3.left;
	rect3.bottom -= rect3.top;

	GetClientRect(hWnd,&rect2);
	if ((rect2.right!=width)||(rect2.bottom!=height))
	{
		SetWindowPos(hWnd, NULL, x, y,
			         rect3.right+(width-rect2.right),
					 rect3.bottom+(height-rect2.bottom),
					 SWP_NOZORDER);
	} else
	{
		SetWindowPos(hWnd, NULL, x, y,
			         0,0,
					 SWP_NOSIZE|SWP_NOZORDER);
	}
}



void init() {
	int i;

	if (openCon) {
		AllocConsole();
		SetConsoleTitle("Dualis debug console");
		hOut = GetStdHandle(STD_OUTPUT_HANDLE);
	}

	// Get the performance counter update frequency
	QueryPerformanceFrequency(&perfFreq);

	// Load plugins
	wsprintf(szBuffer,"%s\\plugins\\arm9.dll",szPath);
	if ((hCPU = LoadLibrary(szBuffer)) == NULL)	{
		WINERROR("LoadLibrary failed for arm9.dll.");
		ExitProcess(0);
	}

	wsprintf(szBuffer,"%s\\plugins\\arm7.dll",szPath);
	if ((hCPUsub = LoadLibrary(szBuffer)) == NULL)	{
		WINERROR("LoadLibrary failed for arm7.dll.");
		ExitProcess(0);
	}

	wsprintf(szBuffer,"%s\\plugins\\dsmmu.dll",szPath);
	if ((hMMU = LoadLibrary(szBuffer)) == NULL)	{
		WINERROR("LoadLibrary failed dsmmu.dll.");
		ExitProcess(0);
	}

	wsprintf(szBuffer,"%s\\plugins\\dsgpu.dll",szPath);
	if ((hGPU = LoadLibrary(szBuffer)) == NULL)	{
		WINERROR("LoadLibrary failed for dsgpu.dll.");
		ExitProcess(0);
	}

	wsprintf(szBuffer,"%s\\plugins\\input.dll",szPath);
	if ((hINP = LoadLibrary(szBuffer)) == NULL)	{
		WINERROR("LoadLibrary failed for input.dll.");
		ExitProcess(0);
	}

	if (soundMasterEnable==2)
		wsprintf(szBuffer,"%s\\plugins\\dsapu_null.dll",szPath);
	else
		wsprintf(szBuffer,"%s\\plugins\\dsapu.dll",szPath);
	if ((hAPU = LoadLibrary(szBuffer)) == NULL)	{
		WINERROR("LoadLibrary failed for dsapu.dll.");
		ExitProcess(0);
	}

	cpu_init = (cpu_init_callback)GetProcAddress(hCPU,"cpu_init");
	cpu_reset = (cpu_reset_callback)GetProcAddress(hCPU,"cpu_reset");
	cpu_get = (cpu_get_callback)GetProcAddress(hCPU,"cpu_get");
	cpu_set = (cpu_set_callback)GetProcAddress(hCPU,"cpu_set");
	cpu_execute_until = (cpu_execute_until_callback)GetProcAddress(hCPU,"cpu_execute_until");

	cpu_sub_init = (cpu_init_callback)GetProcAddress(hCPUsub,"cpu_init");
	cpu_sub_reset = (cpu_reset_callback)GetProcAddress(hCPUsub,"cpu_reset");
	cpu_sub_get = (cpu_get_callback)GetProcAddress(hCPUsub,"cpu_get");
	cpu_sub_set = (cpu_set_callback)GetProcAddress(hCPUsub,"cpu_set");
	cpu_sub_execute_until = (cpu_execute_until_callback)GetProcAddress(hCPUsub,"cpu_execute_until");

	mmu_init = (mmu_init_callback)GetProcAddress(hMMU,"mmu_init");
	mmu_reset = (mmu_reset_callback)GetProcAddress(hMMU,"mmu_reset");
	mmu_get = (mmu_get_callback)GetProcAddress(hMMU,"mmu_get");
	mmu_set = (mmu_set_callback)GetProcAddress(hMMU,"mmu_set");
	mmu_close = (mmu_close_callback)GetProcAddress(hMMU,"mmu_close");
	mmu_read_word = (mmu_read_word_callback)GetProcAddress(hMMU,"mmu_read_word");
	mmu_read_dword = (mmu_read_dword_callback)GetProcAddress(hMMU,"mmu_read_dword");
	mmu_write_byte = (mmu_write_byte_callback)GetProcAddress(hMMU,"mmu_write_byte");
	mmu_write_word = (mmu_write_word_callback)GetProcAddress(hMMU,"mmu_write_word");
	mmu_write_dword = (mmu_write_dword_callback)GetProcAddress(hMMU,"mmu_write_dword");

	gpu_init = (gpu_init_callback)GetProcAddress(hGPU,"gpu_init");
	gpu_reset = (gpu_reset_callback)GetProcAddress(hGPU,"gpu_reset");
	gpu_get = (gpu_get_callback)GetProcAddress(hGPU,"gpu_get");
	gpu_set = (gpu_set_callback)GetProcAddress(hGPU,"gpu_set");
	gpu_hblank = (gpu_hblank_callback)GetProcAddress(hGPU,"gpu_hblank");
	gpu_advance_line = (gpu_advance_line_callback)GetProcAddress(hGPU,"gpu_advance_line");
	gpu_close = (gpu_close_callback)GetProcAddress(hGPU,"gpu_close");

	apu_init = (apu_init_callback)GetProcAddress(hAPU,"apu_init");
	apu_reset = (apu_reset_callback)GetProcAddress(hAPU,"apu_reset");
	apu_get = (apu_get_callback)GetProcAddress(hAPU,"apu_get");
	apu_set = (apu_set_callback)GetProcAddress(hAPU,"apu_set");
	apu_close = (apu_close_callback)GetProcAddress(hAPU,"apu_close");
	apu_update = (apu_update_callback)GetProcAddress(hAPU,"apu_update");

	inp_init = (mmu_init_callback)GetProcAddress(hINP,"inp_init");
	inp_reset = (mmu_reset_callback)GetProcAddress(hINP,"inp_reset");
	inp_get = (mmu_get_callback)GetProcAddress(hINP,"inp_get");
	inp_set = (mmu_set_callback)GetProcAddress(hINP,"inp_set");
	inp_close = (mmu_close_callback)GetProcAddress(hINP,"inp_close");

	if (cpu_init((zombie_callback)hub)==0) {
		WINERROR("cpu_init failed.");
		ExitProcess(0);
	}
	if (cpu_sub_init((zombie_callback)hub)==0) {
		WINERROR("cpu_sub_init failed.");
		ExitProcess(0);
	}

	if (mmu_init((zombie_callback)hub)==0) {
		WINERROR("mmu_init failed.");
		ExitProcess(0);
	}
	mmu_set(PLUGIN_SETTING, 20, ipcFormat);

	if (gpu_init((zombie_callback)hub)==0) {
		WINERROR("gpu_init failed.");
		ExitProcess(0);
	}
	if (gpu_get(GPU_RENDERER_OK)==0) {
		gpu_close();
		mmu_close();
		MessageBox(NULL,"Failed to find a suitable rendering mode.","Error",MB_ICONERROR);
		ExitProcess(0);
	}
	gpu_set(PLUGIN_SETTING, 0, frameskip);
	gpu_set(PLUGIN_SETTING, 1, fpsLimit);
	gpu_set(PLUGIN_SETTING, 20, renderer);

	if (inp_init((zombie_callback)hub)==0) {
		gpu_close();
		mmu_close();
		WINERROR("inp_init failed.");
		ExitProcess(0);
	}
	for (i=0; i<12; i++)
		inp_set(PLUGIN_SETTING,0,(i<<16)|keymap[i]);

	apu_set(PLUGIN_SETTING,0x10,largeSoundBuffer);
	apu_set(PLUGIN_SETTING,0x11,sampleRate);
	if (apu_init((zombie_callback)hub)==0) {
		gpu_close();
		mmu_close();
		WINERROR("apu_init failed.");
		ExitProcess(0);
	}


	mmu_set(PLUGIN_SETTING,70,cfDevice);

	pageTable = (char**)mmu_get(MMU_PAGE_TABLE);
	arm7_pageTable = (char**)mmu_get(MMU_PAGE_TABLE|0x10000);

	romLoaded = false;

	memviewScroll.pos = 0x00800000;
	disasmScroll.pos = 0x02004000>>2;

	arm9PluginVersion = cpu_get(PLUGIN_VERSION);
	arm7PluginVersion = cpu_sub_get(PLUGIN_VERSION);
	mmuPluginVersion  = mmu_get(PLUGIN_VERSION);
	gpuPluginVersion  = gpu_get(PLUGIN_VERSION);
	apuPluginVersion  = apu_get(PLUGIN_VERSION);
	inpPluginVersion  = inp_get(PLUGIN_VERSION);

	if ((arm9PluginVersion<20)||(arm7PluginVersion<20)) {
		apu_close();
		gpu_close();
		mmu_close();
		MessageBox(NULL,"Outdated CPU plugin detected. Version 21 or above required.","Error",MB_ICONERROR);
		ExitProcess(0);
	}

	if (mmuPluginVersion<21) {
		apu_close();
		gpu_close();
		mmu_close();
		MessageBox(NULL,"Outdated MMU plugin detected. Version 21 or above required.","Error",MB_ICONERROR);
		ExitProcess(0);
	}

	// Turbo SWI
	cpu_set(PLUGIN_SETTING,0x333,1);
	cpu_sub_set(PLUGIN_SETTING,0x333,1);

	pendingPause = pendingScreenshot = false;
}



void __stdcall apu_write_stub(unsigned char c1,unsigned char c2) {
}



int __stdcall hub(int direction,int topic,void *param1,void *param2) {
	event e;
	RECT rect;
	HDC subdc;
	int i;
	unsigned int *pt;
	static int deblimit=20;

	switch (direction) {
		case ASK:

			switch(topic) {
				case CPU_IRQ_CALLBACK:
				case CPU_CYCLE_COUNT:
				case CPU_REG:
				case CPU_REG_PC:
				case CPU_DMA_CALLBACK:
					if ((int)param2==0)
						return cpu_get(topic);
					else
						return cpu_sub_get(topic);

				case MMU_PAGE_TABLE:
					pt = (unsigned int*)mmu_get(topic|(((int)param1&1)<<16));
					//for (i=0; i<256; i++) {
					if ((int)param1&1) {
							arm7_pageTable = (char**)pt;
							apu_set(MMU_PAGE_TABLE,(int)pt,1L);
					} else {
						pageTable = (char**)pt;
					}
					return (int)pt;
				case MMU_PAGE_MASKS:
					pt = (unsigned int*)mmu_get(topic|(((int)param1&1)<<16));
					for (i=0; i<256; i++) {
						if ((int)param1&1) 
							arm7_pageMask[i] = pt[i];
						else
							arm9_pageMask[i] = pt[i];
					}

					if ((int)param1&1)
						apu_set(MMU_PAGE_MASKS,(int)pt,1L);
					return (int)pt;

				case MMU_DTCM:
				case MMU_ITCM:
				case MMU_IRQ_OK:
				case MMU_CRC16:
				case MMU_GETSINETB:
				case MMU_GETPITCHTB:
				case MMU_GETVOLTB:
				case MMU_READ_BYTE_CALLBACK:
				case MMU_READ_BYTE_CALLBACKS:
				case MMU_GET_CALLBACK:
				case MMU_READ_WORD_CALLBACK:
				case MMU_READ_WORD_CALLBACKS:
				case MMU_READ_DWORD_CALLBACK:
				case MMU_READ_DWORD_CALLBACKS:
				case MMU_WRITE_BYTE_CALLBACK:
				case MMU_WRITE_BYTE_CALLBACKS:
				case MMU_WRITE_WORD_CALLBACK:
				case MMU_WRITE_WORD_CALLBACKS:
				case MMU_WRITE_DWORD_CALLBACK:
				case MMU_WRITE_DWORD_CALLBACKS:
				case MMU_TRANSLATE_ADDRESS_CALLBACK:
				case MMU_IRQ_CALLBACK:
				case MMU_VRAM_BANKS:
					return mmu_get(topic|(((int)param1&1)<<16));

				case GPU_MEMORY:
					//hub(TELL,ZOMBIE_DEBUG_MSG,"Asking for GPU memory",0);
					return gpu_get(topic);
				case GPU_SET_CALLBACK:
					return (int)gpu_set;
				case GPU_GET_CALLBACK:
					return (int)gpu_get;

				case APU_WRITE_CALLBACK:
					return (int)apu_get(topic);

				case ZOMBIE_WINDOW_HANDLE:
					return (int)windows[(int)param1&0xFF].hwnd;

				case ZOMBIE_ROM_PATH:
					return (int)szRomPath;

				case ZOMBIE_ROM_BASE:
					if ((int)param2==0)
						return (int)cart;
					else
						return (int)cartSub;

				case ZOMBIE_ROM_SIZE:
					wsprintf(szBuffer,"Returning .nds size minus header: %d bytes",gbaCartSize);
					hub(TELL,ZOMBIE_DEBUG_MSG,szBuffer,0);
					return gbaCartSize; 

				case ZOMBIE_GBA_CART:
					return (int)gbacart;

				case ZOMBIE_KEYSTATE:
					return keys[(int)param1 & 0xFF];

				case TOUCHPAD_DATA:
					return (int)&touch;

			}
			//wsprintf(szBuffer,"Return default value (0) for message 0x%X",topic);
			//hub(TELL,ZOMBIE_DEBUG_MSG,szBuffer,0);
			return 0;

		case TELL:
			switch (topic)
			{
				case ZOMBIE_EVENT:
					e.data = (UINT)param1;
					e.timestamp = (UINT)param2;
					eq->enqueue(&e);
					break;

				case MMU_IRQ:
				case MMU_IRQ_OVER:
				case MMU_LZ77_UNPACK_ARM7:
				case MMU_LZ77_UNPACK_ARM9:
				case MMU_LZ77_UNPACK_WRAM_ARM7:
				case MMU_LZ77_UNPACK_WRAM_ARM9:
					mmu_set(topic,(unsigned int)param1,(int)param2);
					break;
				case MMU_READ_WORD_CALLBACKS:
					cpu_set(topic,(unsigned int)param1,(int)param2);
					break;
				case MMU_PAGE_TABLE:
					if ((int)param2==0)
						cpu_set(topic,(unsigned int)param1,(int)param2);
					else
						cpu_sub_set(topic,(unsigned int)param1,(int)param2);
					break;

				case INPUT_KEYDOWN:
					mmu_set(ZOMBIE_KEYSTATE,(unsigned int)param1,1);
					break;
				case INPUT_KEYUP:
					mmu_set(ZOMBIE_KEYSTATE,(unsigned int)param1,0);
					break;

				case ZOMBIE_DEBUG_MSG:
					// string pointer in param1
					if (dbgMsgCount==32) {
						for (i=0; i<31; i++)
							strcpy(dbgMessages[i],dbgMessages[i+1]);
						strncpy(dbgMessages[31],(const char*)param1,48);
					} else
						strncpy(dbgMessages[dbgMsgCount++],(const char*)param1,48);

					si.nPos = dbgMsgPos;
			        si.nMax   = dbgMsgCount-1;
			        SetScrollInfo(hScrollbar1, SB_CTL, &si, TRUE);

					if (windows[4].active) {
						rect2.left = 8;
						rect2.top = 32;
						rect2.right = 250;
						rect2.bottom = -1;
						InvalidateRect(windows[4].hwnd,NULL,TRUE);
					}
					break;

				case MMU_TCM_REMAP:
					mmu_set(topic,(unsigned int)param1,(int)param2);
					break;

				case ZOMBIE_HALT:
					run = false;
					break;

				case CPU_SPEED:
					speed = (UINT)param1;
					break;

				case CPU_CYCLE_PTR:
					mmu_set(topic,(unsigned int)param1,(unsigned int)param2);
					apu_set(topic,(unsigned int)param1,(unsigned int)param2);
					break;

				case CPU_WAKE_UP:
					if ((int)param2==0)
						cpu_set(topic,(unsigned int)param1,(unsigned int)param2);
					else
						cpu_sub_set(topic,(unsigned int)param1,(unsigned int)param2);
					break;

				case CPU_IO_HANDLER:
					cpu_set(topic,(unsigned int)param1,(unsigned int)param2);
					break;

				case CPU_REG_PC:
					if ((int)param2==0)
						cpu_set(topic,(unsigned int)param1,(unsigned int)param2);
					else
						cpu_sub_set(topic,(unsigned int)param1,(unsigned int)param2);
					break;

				case GPU_FRAME_COMPLETED:
					frames++;
					if (windows[3].active && run && (palUpdateMode==4))
						InvalidateRect(windows[3].hwnd,NULL,FALSE);
					if (windows[6].active && run && disAutoUpdate)
						InvalidateRect(windows[6].hwnd,NULL,FALSE);
					if (windows[7].active && run && regviewAutoUpdate)
						InvalidateRect(windows[7].hwnd,NULL,FALSE);
					if (windows[16].active && run && regviewAutoUpdate)
						InvalidateRect(windows[16].hwnd,NULL,FALSE);

					//apu_set(APU_SYNC,currFps,0);

					if (isFullscreen && osdFps) {
						wsprintf(szBuffer,"%d fps  ",currFps);
						subdc = GetDC(hSubScr);
						SetBkMode(subdc,TRANSPARENT);
						SetTextColor(subdc,0xA0A092FF);
						TextOut(subdc,8,8,szBuffer,strlen(szBuffer));
						ReleaseDC(hSubScr,subdc);
					}

					if (pendingPause) {
						run = false;
						pendingPause = false;
					}
					if (pendingScreenshot) {
						pendingScreenshot = false;
						screenshot();
					}
					//apu_mix();
					avi_record_frame();
					break;

				case GPU_VBLANK_ACTION:
				case GPU_HBLANK_ACTION:
					gpu_set(topic,(unsigned int)param1,(unsigned int)param2);
					break;

			}
			return 0;
	}

	//wsprintf(szBuffer,"Bad direction (%X, %X, %X, %X)",direction,topic,param1,param2);
	//hub(TELL,ZOMBIE_DEBUG_MSG,szBuffer,0);
	return 0;
}


unsigned int uncFileSize;


char *load_nds(char *fname, char *buffer, bool fromFile) {
	HANDLE hFile;
	DWORD dwBytesRead,dwFileSize;
	int fileOffset=0;

	if (fromFile) {
		hFile = CreateFile(fname, GENERIC_READ, 0, NULL, OPEN_EXISTING,
		                   FILE_ATTRIBUTE_NORMAL|FILE_FLAG_SEQUENTIAL_SCAN,
			               NULL);
		if (hFile == INVALID_HANDLE_VALUE)
			return 0;
		dwFileSize = GetFileSize(hFile,NULL);
		gbaCartSize = 0;
		if (strcmp(&fname[strlen(fname)-3],"gba")==0) {
			/* Skip the 512 byte loader */
			dwFileSize -= 0x200;
			fileOffset = 0x200;
		}

		if (dwFileSize>0x200) {
			dwFileSize -= 0x200;
			if ((gbacart = (char*)LocalAlloc(LPTR,dwFileSize))==NULL) {
				MessageBox(NULL,"Failed to allocate memory.","Error",MB_ICONERROR);
				if (fromFile) CloseHandle(hFile);
				return NULL;
			}
			gbaCartSize = dwFileSize;
			SetFilePointer(hFile,0x200+fileOffset,NULL,FILE_BEGIN);
			ReadFile(hFile,gbacart,dwFileSize,&dwBytesRead,NULL);
		} 
		SetFilePointer(hFile,fileOffset,NULL,FILE_BEGIN);
		ReadFile(hFile,&hdr,sizeof(NDSFileHeader),&dwBytesRead,NULL);
	} else {
		dwFileSize = uncFileSize;
		gbaCartSize = 0;
		if (strcmp(&fname[strlen(fname)-3],"gba")==0) {
			/* Skip the 512 byte loader */
			dwFileSize -= 0x200;
			fileOffset = 0x200;
		}

		if (dwFileSize>0x200) {
			dwFileSize -= 0x200;
			if ((gbacart = (char*)LocalAlloc(LPTR,dwFileSize))==NULL) {
				MessageBox(NULL,"Failed to allocate memory.","Error",MB_ICONERROR);
				return NULL;
			}
			gbaCartSize = dwFileSize;
			memcpy(gbacart,buffer+0x200+fileOffset,dwFileSize);
		}
		memcpy(&hdr,buffer,sizeof(NDSFileHeader));
	}

	if (hdr.uARM9Size > (64*1024*1024))	{
		wsprintf(szBuffer,"%s will not be loaded. Bad header or invalid file format (ARM9Size = %d)",
			hdr.uARM9Size);
		MessageBox(NULL,szBuffer,"Error",MB_ICONERROR);
		if (fromFile) CloseHandle(hFile);
		return NULL;
	}

	if (hdr.uARM9Size > (32*1024*1024))	{
		wsprintf(szBuffer,"Suspicious ARM9 size: %d bytes.\nAre you sure you wish to proceed?",
				hdr.uARM9Size);
		if (MessageBox(NULL,szBuffer,"Question",MB_YESNO|MB_ICONQUESTION)!=IDYES)
		{
			if (fromFile) CloseHandle(hFile);
			return NULL;
		}
	}

	if (hdr.uARM7Size > (64*1024*1024))	{
		wsprintf(szBuffer,"%s will not be loaded. Bad header or invalid file format (ARM7Size = %d)",
			hdr.uARM7Size);
		MessageBox(NULL,szBuffer,"Error",MB_ICONERROR);
		if (fromFile) CloseHandle(hFile);
		return NULL;
	}

	if (hdr.uARM7Size > (32*1024*1024))	{
		wsprintf(szBuffer,"Suspicious ARM7 size: %d bytes.\nAre you sure you wish to proceed?",
				hdr.uARM7Size);
		if (MessageBox(NULL,szBuffer,"Question",MB_YESNO|MB_ICONQUESTION)!=IDYES)
		{
			if (fromFile) CloseHandle(hFile);
			return NULL;
		}
	}

	/*wsprintf(szBuffer,"arm9 loc: %08X\narm9 exec: %08X\narm9 copyto: %08X\narm9 size: %08X\n",
				hdr.uARM9Source,hdr.uARM9ExecuteFrom,hdr.uARM9CopyTo,hdr.uARM9Size);
	WriteConsole(hOut,szBuffer,strlen(szBuffer),(LPDWORD)&dwDummy,NULL);*/

	romSize = hdr.uARM9Size;
	romSizeSub = hdr.uARM7Size;

	cart = (char*)LocalAlloc(LPTR,romSize+romSizeSub);
	memset(cart,0,romSize+romSizeSub);
	cartSub = cart+romSize;

	if (fromFile) {
		SetFilePointer(hFile,hdr.uARM9Source+fileOffset,NULL,FILE_BEGIN);
		ReadFile(hFile,cart,romSize,&dwBytesRead,NULL);
		if (dwBytesRead != romSize)	{
			LocalFree((HLOCAL)cart);
			return 0;
		}

		SetFilePointer(hFile,hdr.uARM7Source+fileOffset,NULL,FILE_BEGIN);
		ReadFile(hFile,cartSub,romSizeSub,&dwBytesRead,NULL);
		if (dwBytesRead != romSizeSub) {
			LocalFree((HLOCAL)cart);
			return 0;
		}
		CloseHandle(hFile);
	} else {
		memcpy(cart,buffer+hdr.uARM9Source+fileOffset,romSize);
		memcpy(cartSub,buffer+hdr.uARM7Source+fileOffset,romSizeSub);
	}

	EnableMenuItem(menu->popups[0]->hMenu,IDM_ROM_INFO,MF_ENABLED);

	return cart;
}




char *load_arm9_bin(char *fname) {
	HANDLE hFile;
	DWORD dwBytesRead;
	char *p;
	int l;

	hFile = CreateFile(fname, GENERIC_READ, 0, NULL, OPEN_EXISTING,
                       FILE_ATTRIBUTE_NORMAL|FILE_FLAG_SEQUENTIAL_SCAN,
                       NULL);
	if (hFile == INVALID_HANDLE_VALUE)
		return 0;

	romSize = GetFileSize(hFile,NULL);
	romSizeSub = 0;
	cart = (char*)LocalAlloc(LPTR,romSize);
	cartSub = NULL;
	memset(cart,0,romSize);
	ReadFile(hFile,cart,romSize,&dwBytesRead,NULL);
	if (dwBytesRead != romSize)	{
		LocalFree((HLOCAL)cart);
		return 0;
	}
	CloseHandle(hFile);
	hdr.uARM9CopyTo = 0x2004000;
	hdr.uARM9ExecuteFrom = 0x2004000;
	return cart;
}



char *load_rom(char *fname) {
	HANDLE hFile;
	DWORD dwBytesRead;
	HZIP hz;
	ZIPENTRY ze;

	CFileInStream archiveStream;
	CArchiveDatabaseEx db;
	SZ_RESULT res;
	ISzAlloc allocImp;
	ISzAlloc allocTempImp;
	
	char *p,*cart;
	int i,l;
	char *unzipBuffer;

	EnableMenuItem(menu->popups[0]->hMenu,IDM_ROM_INFO,MF_GRAYED);

	if (gbacart) {
		LocalFree(gbacart);
		gbacart = NULL;
	}

	l = lstrlen(fname);
	if (l>3)
	{
		p = &fname[l-3];
		if (strcmp(p,"zip") == 0) {
			hz = OpenZip(fname,"");
			if ((int)hz == 0) {
				return 0;
			}
			// Try at most 256 files
			for (i=0; i<256; i++) {
				if (GetZipItem(hz,i,&ze)) {
					CloseZip(hz);
					return 0;
				}
				if (strlen(ze.name)>4) {
					if (stricmp(&ze.name[strlen(ze.name)-4],".nds") == 0) {
						if (ze.unc_size == -1) {
							CloseZip(hz);
							return 0;
						}
						if ((unzipBuffer = (char*)LocalAlloc(LPTR,ze.unc_size)) == NULL) {
							CloseZip(hz);
							return 0;
						}
						UnzipItem(hz,i,unzipBuffer,ze.unc_size);
						uncFileSize = ze.unc_size;
						cart = load_nds(ze.name,unzipBuffer,false);
						CloseZip(hz);
						LocalFree(unzipBuffer);
						compressedROM = true;
						return cart;
					}
				}
			}
			return 0;

		} else if (strcmp(p,".7z")==0) {
			fopen_s(&archiveStream.File, fname, "rb");
			if (archiveStream.File == 0) {
				return 0;
			}

			archiveStream.InStream.Read = SzFileReadImp;
			archiveStream.InStream.Seek = SzFileSeekImp;

			allocImp.Alloc = SzAlloc;
			allocImp.Free = SzFree;

			allocTempImp.Alloc = SzAllocTemp;
			allocTempImp.Free = SzFreeTemp;

			InitCrcTable();
			SzArDbExInit(&db);
			res = SzArchiveOpen(&archiveStream.InStream, &db, &allocImp, &allocTempImp);
			if (res == SZ_OK) {
				UInt32 i;
				for (i = 0; i < db.Database.NumFiles; i++) {
					CFileItem *f = db.Database.Files + i;
					if (strlen(f->Name)>4) {
					if (stricmp(&f->Name[strlen(f->Name)-4],".nds") == 0) {
						if (f->Size <= 0) {
							SzArDbExFree(&db, allocImp.Free);
							fclose(archiveStream.File);
							return 0;
						}
						/*if ((unzipBuffer = (char*)LocalAlloc(LPTR,ze.unc_size)) == NULL) {
							CloseZip(hz);
							return 0;
						}*/
						UInt32 blockIndex = 0xFFFFFFFF; 
						size_t outBufferSize = 0;
						size_t offset;
						size_t outSizeProcessed;
						unzipBuffer = 0;
						res = SzExtract(&archiveStream.InStream, &db, i, 
								&blockIndex, (Byte**)&unzipBuffer, &outBufferSize, 
								&offset, &outSizeProcessed, 
								&allocImp, &allocTempImp);
						//UnzipItem(hz,i,unzipBuffer,ze.unc_size);
						uncFileSize = f->Size;
						cart = load_nds(f->Name,unzipBuffer,false);
						allocImp.Free((Byte*)unzipBuffer);
						SzArDbExFree(&db, allocImp.Free);
						fclose(archiveStream.File);
						//CloseZip(hz);
						//LocalFree(unzipBuffer);
						compressedROM = true;
						return cart;
					}
				}

					//sprintf(szBuffer,"%10d  %s\n", (int)f->Size, f->Name);
					//WriteConsole(hOut,szBuffer,lstrlen(szBuffer),(unsigned long*)&dwDummy,NULL);
				}
			}
			SzArDbExFree(&db, allocImp.Free);
			fclose(archiveStream.File);
			return 0;

		} else if (strcmp(p,"nds")==0) {
			compressedROM = false;
			return load_nds(fname,NULL,true);
		
		} else if (strcmp(p,"gba")==0) {
			compressedROM = false;
			return load_nds(fname,NULL,true);
		}

	}
	compressedROM = false;
	return load_arm9_bin(fname);
}




int get_openfilename(char *szBuf, char *szTitle, char *szFilter) {
   ofName.lStructSize = sizeof(OPENFILENAME);
   ofName.hwndOwner = hMain;
   ofName.lpstrFilter = szFilter;
   ofName.nFilterIndex = 1;
   ofName.lpstrFile = szBuf;
   ofName.lpstrFileTitle = szFileNameOnly;
   ofName.nMaxFile = 399;
   ofName.nMaxFileTitle = 200;
   ofName.lpstrInitialDir = NULL;
   ofName.lpstrTitle = szTitle;
   ofName.Flags = OFN_EXPLORER | OFN_OVERWRITEPROMPT;
   return (GetOpenFileName(&ofName));
}


int get_savefilename(char *szBuf, char *szTitle, char *szFilter) {
   ofName.lStructSize = sizeof(OPENFILENAME);
   ofName.hwndOwner = hMain;
   ofName.lpstrFilter = szFilter;
   ofName.nFilterIndex = 1;
   ofName.lpstrFile = szBuf;
   ofName.lpstrFileTitle = szFileNameOnly;
   ofName.nMaxFile = 399;
   ofName.nMaxFileTitle = 200;
   ofName.lpstrInitialDir = NULL;
   ofName.lpstrTitle = szTitle;
   ofName.Flags = OFN_EXPLORER | OFN_OVERWRITEPROMPT;
   return (GetSaveFileName(&ofName));
}



HWND create_window(char *pszTitle,char *pszClass,char *pszIcon,char *pszCursor,int nColor,int xdim,int ydim,WNDPROC msgHandler)
{
	HWND hWindow;
	HICON hIcon;
	HCURSOR hCursor;
	WNDCLASSEX wc;
	ATOM aClass;

	if (pszIcon != NULL)
		hIcon = LoadIcon(hInst,pszIcon);
	else
		hIcon = LoadIcon(hInst,MAKEINTRESOURCE(IDI_ICON1)); //IDI_APPLICATION);

	if (pszCursor != NULL)
		hCursor = LoadIcon(hInst,pszCursor);
	else
		hCursor = LoadCursor(NULL,IDC_ARROW);

	wc.cbSize = sizeof(wc);
	wc.style = CS_OWNDC | CS_HREDRAW | CS_VREDRAW;
	wc.hIcon = wc.hIconSm = hIcon;
	wc.cbClsExtra = wc.cbWndExtra = 16;
	wc.hCursor = hCursor;
	wc.hbrBackground = (HBRUSH)MAKEINTRESOURCE(nColor+1);
	wc.hInstance = hInst;
	wc.lpfnWndProc = msgHandler;
	wc.lpszClassName = pszClass;
	wc.lpszMenuName = NULL;

	if ((aClass=RegisterClassExA(&wc))==0)
	{
		WINERROR("RegisterClassEx failed.");
		ExitProcess(0);
	}

	if (strcmp(pszClass,"SbScrClass")==0)
	{
		rect2.top = 0;
		rect2.left = 0;
		rect2.right = 255;
		rect2.bottom = 383;
		AdjustWindowRect(&rect2,WS_POPUP|WS_CAPTION|WS_BORDER|WS_SYSMENU|WS_MINIMIZEBOX,0);
		hWindow = CreateWindowEx(NULL,(LPSTR)aClass,pszTitle,WS_POPUP|WS_CAPTION|WS_BORDER|WS_SYSMENU|WS_MINIMIZEBOX,
			40,40,rect2.right,rect2.bottom,NULL,NULL,hInst,NULL);
	} else
	{
		rect2.right = xdim;
		rect2.bottom = ydim;
		hWindow = CreateWindowEx(NULL,(LPSTR)aClass,pszTitle,WS_CAPTION|WS_BORDER|WS_SYSMENU|WS_MINIMIZEBOX, //(WS_OVERLAPPED|WS_CAPTION|WS_SYSMENU|WS_THICKFRAME|WS_MINIMIZEBOX),
			40,40,rect2.right,rect2.bottom,NULL,NULL,hInst,NULL);
	}


	if (hWindow==NULL)
	{
		WINERROR("CreateWindowEx failed.");
		ExitProcess(0);
	}

	return hWindow;
}







/////////////////////////////////////////////////////////////////////////////////////////


DWORD *lpfnOldWndProc;

LRESULT CALLBACK input_proc(HWND hwnd,UINT uMsg,WPARAM wParam,LPARAM lParam)
{

	if (hwnd == hMain)
	{
		switch (uMsg)
		{
			case WM_KEYDOWN:

				keys[wParam&0xFF] = 1;
				mmu_set(ZOMBIE_KEYSTATE,wParam&0xFF,1);
				switch (wParam)
				{
					case VK_F5:
						if (romLoaded)
							run = true;
						break;
					/*case VK_F6:
						if (romLoaded)
							run = false;
						break;
					case VK_F7:
						if (romLoaded)
							reset_machine(false);
						break;*/

					case VK_ESCAPE:
						PostMessage(hwnd, WM_CLOSE, wParam, lParam);
						break;

				}
				break;

			case WM_KEYUP:
				keys[wParam&0xFF] = 0;
				mmu_set(ZOMBIE_KEYSTATE,wParam&0xFF,0);
				break;

			//case WM_CLOSE:
			case WM_DESTROY:
				SetWindowLong(hMain, GWL_WNDPROC, (DWORD)lpfnOldWndProc);
				break;
		}
	}

	return CallWindowProc((WNDPROC)lpfnOldWndProc,hwnd,uMsg,wParam,lParam);
}



LRESULT CALLBACK wnd_proc(HWND hwnd,UINT uMsg,WPARAM wParam,LPARAM lParam)
{
	RECT rect;
	HDC dc;
	HWND hdlg,hwndFocus;
	int i;
	DWORD dwTick;
	pTransferRegion pIPC;
    char *romName;

	if (hwnd == hMain)
	{
		switch (uMsg)
		{
			case WM_DROPFILES:
					if (romLoaded)
					{
						run = false;
						//memset(cart,0,romSize);
						LocalFree((HLOCAL)cart);
						romLoaded = false;
					}
					//SendMessage(hStatus,SB_SETTEXT,1,(LPARAM)szFileNameOnly);
					DragQueryFile((HDROP)wParam,0,szFnBuffer,256);
					DragFinish((HDROP)wParam);
					cart = load_rom(szFnBuffer);
					if (cart)
					{
						add_recent_file(szFnBuffer);
						//wsprintf(szBuffer,"Loaded ROM: %s",szFileNameOnly);
						//hub(TELL,ZOMBIE_DEBUG_MSG,szBuffer,0);
						romLoaded = true;
						reset_machine(true);
						//SendMessage(hStatus,SB_SETTEXT,1,(LPARAM)szFileNameOnly);
						run = true;
					} else
					{
						SendMessage(hStatus,SB_SETTEXT,1,(LPARAM)"No ROM loaded");
						run = false;
					}
					break;

			case WM_COMMAND:
				switch (LOWORD(wParam))
				{
					case IDM_RECENT1:
					case IDM_RECENT2:
					case IDM_RECENT3:
					case IDM_RECENT4:
					case IDM_RECENT5:
					case IDM_RECENT6:
					case IDM_RECENT7:
					case IDM_RECENT8:
						if (strlen(recentFiles[LOWORD(wParam)-IDM_RECENT1]))
						{
							romName = recentFiles[LOWORD(wParam)-IDM_RECENT1];
							if (romName[0] == '\"')	{
								romName[strlen(romName)-1] = '\0';
								romName++;
								strcpy(szBuffer3, romName);
								for (i = strlen(romName)-1; i>0; i--)
									if (romName[i] == '\\') break;
								strncpy(szRomPath, romName, i);
								szRomPath[i+1] = '\0';
							}
							else if (!((strchr(romName,':')!=NULL) || (romName[0]=='\\'))) {
								wsprintf(szBuffer3,"%s\\%s", currDir, romName);
								strcpy(szRomPath, currDir);
							} else {
								strcpy(szBuffer3,romName);
								for (i = strlen(romName)-1; i > 0; i--)
									if (romName[i] == '\\') break;
								strncpy(szRomPath, romName, i);
								szRomPath[i+1] = '\0';
							}
							cart = load_rom(recentFiles[LOWORD(wParam)-IDM_RECENT1]);
						}
						if (cart) {
							//add_recent_file(szFnBuffer);
							romLoaded = true;
							reset_machine(true);
							run = true;
						} else {
							SendMessage(hStatus,SB_SETTEXT,1,(LPARAM)"No ROM loaded");
							run = false;
						}
						break;
					
					case IDM_LOAD_AND_EXEC:
						if (!get_openfilename(szFnBuffer,"Load ROM","ROM files (*.bin,*.nds,*.ds.gba,*.zip,*.7z)\0*.bin;*.nds;*.ds.gba;*.zip;*.7z\0"))
						{
							//COMMDLGERROR("OFN failed.");
							break;
						}
						if (ofName.nFileOffset>0)
						{
							strncpy(szRomPath,szFnBuffer,ofName.nFileOffset-1);
						    szRomPath[ofName.nFileOffset-1] = '\0';
						}
						if (romLoaded) {
							run = false;
							LocalFree((HLOCAL)cart);
							romLoaded = false;
						}
						SendMessage(hStatus,SB_SETTEXT,1,(LPARAM)szFileNameOnly);
						cart = load_rom(szFnBuffer);
						if (cart) {
							add_recent_file(szFnBuffer);
							wsprintf(szBuffer,"Loaded ROM: %s",szFileNameOnly);
							hub(TELL,ZOMBIE_DEBUG_MSG,szBuffer,0);
							romLoaded = true;
							reset_machine(true);
							SendMessage(hStatus,SB_SETTEXT,1,(LPARAM)szFileNameOnly);
							run = true;
						} else {
							SendMessage(hStatus,SB_SETTEXT,1,(LPARAM)"No ROM loaded");
							run = false;
						}
						break;

					case IDM_LOAD:
						if (!get_openfilename(szFnBuffer,"Load ROM","ROM files (*.bin,*.nds,*.zip,*.7z)\0*.bin;*.nds;*.zip;*.7z\0"))
						{
							//COMMDLGERROR("OFN failed.");
							break;
						}
						if (ofName.nFileOffset>0)
						{
							strncpy(szRomPath,szFnBuffer,ofName.nFileOffset-1);
							szRomPath[ofName.nFileOffset-1] = '\0';
						}
						run = false;
						if (romLoaded) {
							LocalFree((HLOCAL)cart);
							romLoaded = false;
						}

						SendMessage(hStatus,SB_SETTEXT,1,(LPARAM)&szFileNameOnly);
						cart = load_rom(szFnBuffer);
						if (cart) {
							add_recent_file(szFnBuffer);
							wsprintf(szBuffer,"Loaded ROM: %s",szFileNameOnly);
							hub(TELL,ZOMBIE_DEBUG_MSG,szBuffer,0);
							romLoaded = true;
							reset_machine(true);
						}
						break;

					case IDM_ROM_INFO:
						wsprintf(szBuffer,"Title: %s\n\nARM9 location: \t\t0x%08X\nARM9 execute from: \t0x%08X  \nARM9 copy to: \t\t0x%08X\nARM9 size: \t\t0x%08X\n\nARM7 location: \t\t0x%08X\nARM7 execute from: \t0x%08X\nARM7 copy to: \t\t0x%08X\nARM7 size: \t\t0x%08X\n",
									hdr.szGameTitle,hdr.uARM9Source,hdr.uARM9ExecuteFrom,hdr.uARM9CopyTo,hdr.uARM9Size,
									hdr.uARM7Source,hdr.uARM7ExecuteFrom,hdr.uARM7CopyTo,hdr.uARM7Size);
						MessageBox(NULL,szBuffer,"ROM info",MB_OK);
						break;


					case IDM_FULLSCREEN:
						DEVMODE screenSettings;
						memset(&screenSettings,0,sizeof(screenSettings));
						screenSettings.dmSize       = sizeof(screenSettings);
						EnumDisplaySettings(NULL,ENUM_CURRENT_SETTINGS,&screenSettings);
						if (!isFullscreen) {
							memcpy(&originalSettings,&screenSettings,sizeof(screenSettings));
						
							screenSettings.dmPelsWidth  = fullscreenWidth;			
							screenSettings.dmPelsHeight = fullscreenHeight;			
							screenSettings.dmFields     = DM_PELSWIDTH | DM_PELSHEIGHT;

							SetForegroundWindow(hSubScr);
							SetWindowLong(hSubScr,GWL_STYLE,WS_POPUP);
							ShowWindow(hSubScr,SW_SHOW);
							SetWindowPos(hSubScr,HWND_TOP,0,0,fullscreenWidth,fullscreenHeight,SWP_FRAMECHANGED);      

							if (ChangeDisplaySettings(&screenSettings, CDS_FULLSCREEN) != DISP_CHANGE_SUCCESSFUL){
								MessageBox(NULL,"Cannot run in the fullscreen mode at the selected resolution\n"
												"on your video card.",
												"Dualis",
									 			MB_OK | MB_ICONEXCLAMATION);

								return 0;
							}
							SetForegroundWindow(hSubScr);
							SetFocus(hSubScr);
							isFullscreen = true;
						} else {
							SetWindowLong(hSubScr,GWL_STYLE,WS_POPUP|WS_CAPTION|WS_BORDER|WS_SYSMENU|WS_MINIMIZEBOX);
							ShowWindow(hSubScr,SW_SHOW);
							/*rect2.top = 0;
							rect2.left = 0;
							rect2.right = 255;
							rect2.bottom = 383;
							AdjustWindowRect(&rect2,WS_POPUP|WS_CAPTION|WS_BORDER|WS_SYSMENU|WS_MINIMIZEBOX,0);
							SetWindowPos(hSubScr,HWND_TOP,0,0,rect2.right,rect2.bottom,SWP_FRAMECHANGED);      
							*/
							GetWindowRect(hSubScr,&rect);
							force_window_size(hSubScr,rect.left,rect.top,256,(displayScreens==3)?384:192);

							if (ChangeDisplaySettings(&originalSettings, CDS_FULLSCREEN) != DISP_CHANGE_SUCCESSFUL){
								MessageBox(NULL,"Unable to switch back to windowed mode\n",
												"Dualis",
									 			MB_OK | MB_ICONEXCLAMATION);

								return 0;
							}
							SetForegroundWindow(hSubScr);
							SetFocus(hSubScr);
							isFullscreen = false;
						}
						break;


					case IDM_DISP1:
					case IDM_DISP2:
						displayScreens = (LOWORD(wParam)==IDM_DISP1)?1:2;

						gpu_set(PLUGIN_SETTING,25,displayScreens);
						if (!isFullscreen) {
							GetWindowRect(hSubScr,&rect);
							force_window_size(hSubScr,rect.left,rect.top,256,192);
						}
						touchAreaStart = 0;
						break;
					case IDM_DISP3:
						displayScreens = 3;
						gpu_set(PLUGIN_SETTING,25,displayScreens);
						if (!isFullscreen) {
							GetWindowRect(hSubScr,&rect);
							force_window_size(hSubScr,rect.left,rect.top,256,384);
							touchAreaStart = 192;
						} else {
							touchAreaStart = fullscreenHeight/2;
						}
						break;

					case IDM_SHOWFPS:
						if (isFullscreen)
							osdFps = (!osdFps);
						break;


					// The reason for postponing the screenshot is to be able to get a
					// finished frame instead of a partially rendered one. If the emulator
					// is in a paused state (run==false) we already have a finished frame,
					// so we can go ahead with taking the screenshot right away.
					//
					case IDM_SCREEN_MAIN:
						hwndFocus = GetFocus();
						if ((!romLoaded) || ((hwndFocus!=hMain) && (hwndFocus!=hSubScr)))
							break;
						bmpFrameSelection = GPU_FRAMEBUFFER_MAIN_BGR24;
						if (run)
							pendingScreenshot = true;
						else
							screenshot();
						break;
					case IDM_SCREEN_SUB:
						hwndFocus = GetFocus();
						if ((!romLoaded) || ((hwndFocus!=hMain) && (hwndFocus!=hSubScr)))
							break;
						bmpFrameSelection = GPU_FRAMEBUFFER_SUB_BGR24;
						if (run)
							pendingScreenshot = true;
						else
							screenshot();
						break;
					case IDM_SCREEN_BOTH:
						hwndFocus = GetFocus();
						if ((!romLoaded) || ((hwndFocus!=hMain) && (hwndFocus!=hSubScr)))
							break;
						bmpFrameSelection = GPU_FRAMEBUFFER_BGR24;
						if (run)
							pendingScreenshot = true;
						else
							screenshot();
						break;

					case IDM_CLOSE:
						if (romLoaded)
							LocalFree((HLOCAL)cart);
						cart = NULL;
						romLoaded = false;
						run = false;
						SendMessage(hStatus,SB_SETTEXT,1,(LPARAM)"No ROM loaded");
						break;

					case IDM_EXIT:
						PostMessage(hwnd,WM_CLOSE,wParam,lParam);
						break;

					case IDM_RUN:
						if (romLoaded) {
							run = true;
							apu_set(APU_PAUSE,1-soundMasterEnable,0);
						}
						break;

					case IDM_PAUSE:
						if (romLoaded && run)
							pendingPause = true;
						if (aviIsRecording)
							avi_stop_recording();
						apu_set(APU_PAUSE,1,0);
							//run = false;
						break;

					case IDM_RESET:
						if (romLoaded)
							reset_machine(false);
						break;

					case IDM_BLOCK_DMA:
						mmu_set(PLUGIN_SETTING,63,blockDMA);
						blockDMA = 1-blockDMA;
						break;

					case IDM_PALETTE:
						if (!windows[3].active) {
							GetWindowRect(hwnd,&rect);
							hdlg = CreateDialog(hInst,MAKEINTRESOURCE(IDD_DIALOG10),hwnd,(DLGPROC)DlgProc10);
							windows[3].hwnd = hdlg;
							windows[3].active = true;
							SetWindowPos(hdlg,NULL,rect.left,rect.bottom+20,0,0,SWP_NOSIZE|SWP_NOZORDER);						ShowWindow(hdlg,SW_SHOW);
							ShowWindow(hdlg,SW_SHOW);
							SetForegroundWindow(hwnd);
						}
						break;

					case IDM_DBGCON:
						if (GetFocus()!=hMain) return DefWindowProc(hwnd,uMsg,wParam,lParam);
						if (!windows[4].active) {
							GetWindowRect(hwnd,&rect);
							hdlg = CreateDialog(hInst,MAKEINTRESOURCE(IDD_DIALOG8),hwnd,(DLGPROC)DlgProc8);
							windows[4].hwnd = hdlg;
							windows[4].active = true;
							SetWindowPos(hdlg,NULL,rect.left,rect.bottom+20,0,0,SWP_NOSIZE|SWP_NOZORDER);						ShowWindow(hdlg,SW_SHOW);
							SetForegroundWindow(hwnd);
						}
						break;

					case IDM_MEMORY:
						if (!windows[5].active) {
							GetWindowRect(hwnd,&rect);
							hdlg = CreateDialog(hInst,MAKEINTRESOURCE(IDD_DIALOG7),hwnd,(DLGPROC)DlgProc7);
							windows[5].hwnd = hdlg;
							windows[5].active = true;
							SetWindowPos(hdlg,NULL,rect.left+300,rect.bottom+20,0,0,SWP_NOSIZE|SWP_NOZORDER);						ShowWindow(hdlg,SW_SHOW);
							ShowWindow(hdlg,SW_SHOW);
							SetForegroundWindow(hwnd);
						}
						break;

					case IDM_DISASM:
						if (!windows[6].active) {
							GetWindowRect(hwnd,&rect);
							hdlg = CreateDialog(hInst,MAKEINTRESOURCE(IDD_DIALOG9),hwnd,(DLGPROC)DlgProc9);
							windows[6].hwnd = hdlg;
							windows[6].active = true;
							SetWindowPos(hdlg,NULL,rect.left+300,rect.bottom+20,0,0,SWP_NOSIZE|SWP_NOZORDER);						ShowWindow(hdlg,SW_SHOW);
							ShowWindow(hdlg,SW_SHOW);
							SetForegroundWindow(hwnd);
						}
						break;

					case IDM_IOREGS:
						if (!windows[7].active) {
							GetWindowRect(hwnd,&rect);
							hdlg = CreateDialog(hInst,MAKEINTRESOURCE(IDD_DIALOG11),hwnd,(DLGPROC)DlgProc11);
							windows[7].hwnd = hdlg;
							windows[7].active = true;
							SetWindowPos(hdlg,NULL,rect.left+280,rect.top+80,0,0,SWP_NOSIZE|SWP_NOZORDER);						ShowWindow(hdlg,SW_SHOW);
							ShowWindow(hdlg,SW_SHOW);
							SetForegroundWindow(hwnd);
						}
						break;

					case IDM_IOREGS7:
						if (!windows[16].active) {
							GetWindowRect(hwnd,&rect);
							hdlg = CreateDialog(hInst,MAKEINTRESOURCE(IDD_DIALOG21),hwnd,(DLGPROC)DlgProc21);
							windows[16].hwnd = hdlg;
							windows[16].active = true;
							SetWindowPos(hdlg,NULL,rect.left+280,rect.top+80,0,0,SWP_NOSIZE|SWP_NOZORDER);						ShowWindow(hdlg,SW_SHOW);
							ShowWindow(hdlg,SW_SHOW);
							SetForegroundWindow(hwnd);
						}
						break;

					case IDM_TILES:
						if (!windows[8].active) {
							GetWindowRect(hwnd,&rect);
							hdlg = CreateDialog(hInst,MAKEINTRESOURCE(IDD_DIALOG12),hwnd,(DLGPROC)DlgProc12);
							windows[8].hwnd = hdlg;
							windows[8].active = true;
							SetWindowPos(hdlg,NULL,rect.left+280,rect.top+80,0,0,SWP_NOSIZE|SWP_NOZORDER);						ShowWindow(hdlg,SW_SHOW);
							ShowWindow(hdlg,SW_SHOW);
							SetForegroundWindow(hwnd);
						}
						break;

					case IDM_MAP:
						if (!windows[12].active) {
							GetWindowRect(hwnd,&rect);
							hdlg = CreateDialog(hInst,MAKEINTRESOURCE(IDD_DIALOG18),hwnd,(DLGPROC)DlgProc18);
							windows[12].hwnd = hdlg;
							windows[12].active = true;
							SetWindowPos(hdlg,NULL,rect.left+280,rect.top+80,0,0,SWP_NOSIZE|SWP_NOZORDER);						ShowWindow(hdlg,SW_SHOW);
							ShowWindow(hdlg,SW_SHOW);
							SetForegroundWindow(hwnd);
						}
						break;

					case IDM_OAM:
						if (!windows[13].active) {
							GetWindowRect(hwnd,&rect);
							hdlg = CreateDialog(hInst,MAKEINTRESOURCE(IDD_DIALOG17),hwnd,(DLGPROC)DlgProc17);
							windows[13].hwnd = hdlg;
							windows[13].active = true;
							SetWindowPos(hdlg,NULL,rect.left+280,rect.top+80,0,0,SWP_NOSIZE|SWP_NOZORDER);						ShowWindow(hdlg,SW_SHOW);
							ShowWindow(hdlg,SW_SHOW);
							SetForegroundWindow(hwnd);
						}
						break;
					case IDM_TEXTURE:
						if (!windows[14].active) {
							GetWindowRect(hwnd,&rect);
							hdlg = CreateDialog(hInst,MAKEINTRESOURCE(IDD_DIALOG19),hwnd,(DLGPROC)DlgProc19);
							windows[14].hwnd = hdlg;
							windows[14].active = true;
							SetWindowPos(hdlg,NULL,rect.left+280,rect.top+80,0,0,SWP_NOSIZE|SWP_NOZORDER);						ShowWindow(hdlg,SW_SHOW);
							ShowWindow(hdlg,SW_SHOW);
							SetForegroundWindow(hwnd);
						}
						break;

					case IDM_MATRIX:
						if (!windows[15].active) {
							GetWindowRect(hwnd,&rect);
							hdlg = CreateDialog(hInst,MAKEINTRESOURCE(IDD_DIALOG20),hwnd,(DLGPROC)DlgProc20);
							windows[15].hwnd = hdlg;
							windows[15].active = true;
							SetWindowPos(hdlg,NULL,rect.left+280,rect.top+80,0,0,SWP_NOSIZE|SWP_NOZORDER);						ShowWindow(hdlg,SW_SHOW);
							ShowWindow(hdlg,SW_SHOW);
							SetForegroundWindow(hwnd);
						}
						break;

					case IDM_MOVIE_START:
						avi_start_recording();
						if (aviIsRecording)
							SetWindowText(hMain,"Dualis [Recording]");
						break;
					case IDM_MOVIE_STOP:
						SetWindowText(hMain,"Dualis");
						if (aviIsRecording)
							avi_stop_recording();
						break;
					case IDM_MOVIE_SETUP:
						if (GetFocus()!=hMain) return DefWindowProc(hwnd,uMsg,wParam,lParam);
						hdlg = CreateDialog(hInst,MAKEINTRESOURCE(IDD_DIALOG16),hwnd,(DLGPROC)DlgProc16);
						windows[11].hwnd = hdlg;
						windows[11].active = true;
						ShowWindow(hdlg,SW_SHOW);
						SetForegroundWindow(hwnd);

						break;

					case IDM_BREAKPOINTS:
						GetWindowRect(hwnd,&rect);
						hdlg = CreateDialog(hInst,MAKEINTRESOURCE(IDD_DIALOG13),hwnd,(DLGPROC)DlgProc13);
						windows[9].hwnd = hdlg;
						windows[9].active = true;
						SetWindowPos(hdlg,NULL,rect.left+120,rect.top+60,0,0,SWP_NOSIZE|SWP_NOZORDER);						ShowWindow(hdlg,SW_SHOW);
						ShowWindow(hdlg,SW_SHOW);
						SetForegroundWindow(hwnd);
						break;

					case IDM_ABOUT:
						DialogBoxParam(hInst,
								 MAKEINTRESOURCE(IDD_DIALOG5), hMain,
								 DlgProc5, NULL);

				}
				return 0;

			case WM_ACTIVATE:
				SendMessage(hPropsheet,uMsg,wParam,lParam);
				break;

			case WM_SIZE:
				center_propsheet(lParam);

				if (hStatus != NULL)
				{
					rect.left = 170;//440-100;
					rect.top = 170+180;//440;
					rect.right = -1;
					rect.bottom = -1;
	            	SendMessage(hStatus, SB_SETPARTS, 3, (LPARAM)&rect);
	            	SendMessage(hStatus, WM_SIZE, wParam, lParam);
					//SendMessage(hStatus,SB_SETTEXT,0,(LPARAM)"CPU: 0.0 MHz  GPU: 0 fps");
					//SendMessage(hStatus,SB_SETTEXT,1,(LPARAM)"No ROM loaded");

				}
				/*if (romLoaded)
					SendMessage(hStatus,SB_SETTEXT,1,(LPARAM)szFileNameOnly);
				else
					SendMessage(hStatus,SB_SETTEXT,1,(LPARAM)"No ROM loaded");

				if (run)
					SendMessage(hStatus,SB_SETTEXT,2,(LPARAM)"Running");
				else
					SendMessage(hStatus,SB_SETTEXT,2,(LPARAM)"Idle");*/

				break;

			case WM_KEYDOWN:
				//keys[wParam&0xFF] = 1;
				//mmu_set(ZOMBIE_KEYSTATE,wParam&0xFF,1);

				switch (wParam)
				{
					/*case '7':
						mmu_set(PLUGIN_SETTING,111,0);
						break;*/

					case VK_F5:
						if (romLoaded) {
							run = true;
							apu_set(APU_PAUSE,1-soundMasterEnable,0);
						}
						break;
					case VK_F6:
						if (romLoaded && run)
							pendingPause = true;
						apu_set(APU_PAUSE,1,0);
							//run = false;
						break;
					case VK_F7:
						if (romLoaded)
							reset_machine(false);
						break;

					case VK_ESCAPE:
						run = false;
						PostMessage(hwnd, WM_CLOSE, wParam, lParam);
						break;

					/*case 'J':
						//start_avi();
						break;
					case 'K':
						//stop_avi();
						MessageBox(NULL,"Stopping AVI output","Message",MB_OK);
						break;
					case 'H':
						hdlg = CreateDialog(hInst,MAKEINTRESOURCE(IDD_DIALOG16),hwnd,(DLGPROC)DlgProc16);
						windows[11].hwnd = hdlg;
						windows[11].active = true;
						ShowWindow(hdlg,SW_SHOW);
						SetForegroundWindow(hwnd);
						break;*/

					/*case 'D':
						wsprintf(szBuffer,"PC = %08X\n",cpu_get(CPU_REG_PC));
						WriteConsole(hOut,szBuffer,lstrlen(szBuffer),(unsigned long*)&dwDummy,NULL);
						break;

					case 'G':
						wsprintf(szBuffer,"%04X%04x\n",mmu_read_word(0x4000002),mmu_read_word(0x4000000));
						WriteConsole(hOut,szBuffer,lstrlen(szBuffer),(unsigned long*)&dwDummy,NULL);

						//wsprintf(szBuffer,"%04x %04x\n",mmu_read_word(0x4000050),mmu_read_word(0x4000052));
						//WriteConsole(hOut,szBuffer,lstrlen(szBuffer),(unsigned long*)&dwDummy,NULL);

						wsprintf(szBuffer,"%04x %04x %04X %04X\n",mmu_read_word(0x4001008),mmu_read_word(0x400100a),
							mmu_read_word(0x400100c),mmu_read_word(0x400100e));
						WriteConsole(hOut,szBuffer,lstrlen(szBuffer),(unsigned long*)&dwDummy,NULL);

						for (i=0; i<16; i++)
						{
						wsprintf(szBuffer,"%04X ",mmu_read_word(0x7000400+(i<<1)));
						WriteConsole(hOut,szBuffer,lstrlen(szBuffer),(unsigned long*)&dwDummy,NULL);
						}
						WriteConsole(hOut,"\n",2,(LPDWORD)&i,NULL);*/
				}
				return 0;

			case WM_KEYUP:
				//keys[wParam&0xFF] = 0;
				//mmu_set(ZOMBIE_KEYSTATE,wParam&0xFF,0);
				return 0;

			case WM_TIMER:
				// This has to be done here since the multimedia timer is asynchronous, which would sometimes
				// mess up the event queue timestamps.
				if (wParam = 777)
				{
					// Prevent timestamp overflows
					if (cycles >= 0x40000000) {
						cpu_set(CPU_CYCLE_COUNT,cycles-0x40000000,0);
						cycles = cpu_get(CPU_CYCLE_COUNT);
						//hub(TELL,ZOMBIE_DEBUG_MSG,"OF on 9",0);
						for (i=0; i<eq->nItems; i++)
							if (eq->e[i].timestamp >= 0x40000000)
								eq->e[i].timestamp -= 0x40000000;
					}
					if (arm7_cycles >= 0x40000000) {
						cpu_sub_set(CPU_CYCLE_COUNT,arm7_cycles-0x40000000,0);
						arm7_cycles = cpu_sub_get(CPU_CYCLE_COUNT);
						//hub(TELL,ZOMBIE_DEBUG_MSG,"OF on 7",0);
						for (i=0; i<eq->nItems; i++)
							if (eq->e[i].timestamp >= 0x40000000)
								eq->e[i].timestamp -= 0x40000000;
					}
				}
				return DefWindowProc(hwnd,uMsg,wParam,lParam);
				if (wParam == 777)
				{
					dwTick = GetTickCount();
					if (samples)
						cpuEmuSpeed *= (float)perfFreq.QuadPart/(float)(cpu_get(CPU_CYCLE_SCALING)*samples);
					else
						cpuEmuSpeed = 0.0f;
					/*wsprintf(szBuffer,"CPU: %d MHz\tGPU %d fps    ",
							(UINT)(cpuEmuSpeed/((float)(dwTick-dwTimerOf)*1000.0f)),
							(UINT)((float)frames*1000.0f / (float)(dwTick-dwTimerOf)));*/
					wsprintf(szBuffer,"CPU: %d MHz      ",
							(UINT)(cpuEmuSpeed/((float)(dwTick-dwTimerOf)*1000.0f)));
					currFps = (UINT)((float)frames*1000.0f / (float)(dwTick-dwTimerOf));
					wsprintf(&szBuffer[16],"GPU: %d fps   ",currFps);
					SendMessage(hStatus,SB_SETTEXT,0,(LPARAM)szBuffer);
					
					frames = 0;
					cpuEmuSpeed = 0.0f;
					samples = 0;
					dwTimerOf = dwTick;

					/*systime.wSecond++;
					if (systime.wSecond==60)
					{
						systime.wSecond = 0;
						systime.wMinute++;
						if (systime.wMinute==60)
						{
							systime.wMinute = 0;
							systime.wHour++;
							if (systime.wHour==24)
							{
								GetLocalTime(&systime);
							}
						}
					}*/
					GetLocalTime(&systime);

					pIPC = (pTransferRegion)pageTable[0x20];

					// Update IPC time data
					if (false) //ipcLoc)
					{
						mmu_write_dword(0x237F016,((systime.wYear-1744)<<24)|(systime.wMinute<<16)|(systime.wSecond<<8)|(systime.wSecond<<0));
						mmu_write_dword(0x237F01A,(systime.wHour<<24)|(systime.wMonth<<8)|(systime.wDay)|(systime.wSecond<<16));
						//mmu_write_dword(0x237F016,0x04030201);
						//mmu_write_dword(0x237F01A,0x08070605);
					} else
					{
						if (romLoaded)
						{
							/*pIPC->year = 5;
							pIPC->month = systime.wMonth;
							pIPC->day = systime.wDay;
							pIPC->hours = systime.wHour;
							pIPC->minutes = systime.wMinute;
							pIPC->seconds = systime.wSecond;*/

							if (systime.wHour > 11) systime.wHour += 40;

							/**(unsigned int*)(pageTable[0x20] + 22) = ((systime.wYear-1744)<<24)|0x070907; //((systime.wYear-1744)<<8) | (systime.wMonth<<16) | (systime.wDay<<24);
							*(unsigned int*)(pageTable[0x20] + 26) = ((systime.wHour)<<24)|(systime.wMonth)|(systime.wDay<<8); //(systime.wMonth);
							*(unsigned int*)(pageTable[0x20] + 30) = (systime.wSecond<<8)|(systime.wMinute);
							*(unsigned int*)(pageTable[0x20] + 34) = 0x08070608;*/

							if (mirrorIPC)
							{
							//*(unsigned int*)(pageTable[0x23] + 0xFF01A) = ((systime.wYear-1744)<<24)|0x070907; //((systime.wYear-1744)<<8) | (systime.wMonth<<16) | (systime.wDay<<24);
							//*(unsigned int*)(pageTable[0x23] + 0xFF01E) = ((systime.wHour)<<24)|(systime.wMonth)|(systime.wDay<<8); //(systime.wMonth);
							//*(unsigned int*)(pageTable[0x23] + 0xFF022) = (systime.wSecond<<8)|(systime.wMinute);
							//*(unsigned int*)(pageTable[0x23] + 0xFF026) = 0x08070608;
							}
							//mmu_write_dword(0x2000016,0x0E|((systime.wYear-1744)<<8)|(systime.wMonth<<16)|(systime.wDay<<24));
						//mmu_write_dword(0x200001A,0x00|(systime.wHour<<8)|(systime.wMinute<<16)|(systime.wSecond<<24));
						//mmu_write_dword(0x2000016,((systime.wYear-1744)<<24)|(systime.wMinute<<16)|(systime.wSecond<<8)|(systime.wSecond<<0));
						//mmu_write_dword(0x200001A,(systime.wHour<<24)|(systime.wMonth<<8)|(systime.wDay)|(systime.wSecond<<16));
						}
					}
					// Prevent timestamp overflows
					if (cycles >= 0x40000000) {
						cpu_set(CPU_CYCLE_COUNT,cycles-0x40000000,0);
						cycles = cpu_get(CPU_CYCLE_COUNT);
						hub(TELL,ZOMBIE_DEBUG_MSG,"OF on 9",0);
						for (i=0; i<eq->nItems; i++)
							if (eq->e[i].timestamp >= 0x40000000)
								eq->e[i].timestamp -= 0x40000000;
					}
					if (arm7_cycles >= 0x40000000) {
						cpu_sub_set(CPU_CYCLE_COUNT,arm7_cycles-0x40000000,0);
						arm7_cycles = cpu_sub_get(CPU_CYCLE_COUNT);
						hub(TELL,ZOMBIE_DEBUG_MSG,"OF on 7",0);
						for (i=0; i<eq->nItems; i++)
							if (eq->e[i].timestamp >= 0x40000000)
								eq->e[i].timestamp -= 0x40000000;
					}

					if (windows[3].active && run && (palUpdateMode==5))
						InvalidateRect(windows[3].hwnd,NULL,FALSE);
				}
				break;

			case WM_CLOSE:
	  			run = false;
  				quit = true;
  				return 0;

			case WM_DESTROY:
 				KillTimer(hwnd,777);
	 			PostQuitMessage(0);
	  			return 0;
		}


	} else if (hwnd == hSubScr)
	{
		switch (uMsg)
		{
			case WM_KEYDOWN:
				switch (wParam)
				{
					case VK_F5:
						if (romLoaded) {
							run = true;
							apu_set(APU_PAUSE,1-soundMasterEnable,0);
						}
						break;
					case VK_F6:
						if (romLoaded)
							run = false;
						apu_set(APU_PAUSE,1,0);
						break;
					case VK_F7:
						if (romLoaded)
							reset_machine(false);
						break;
					case VK_ESCAPE:
						run = false;
						PostMessage(hwnd, WM_CLOSE, wParam, lParam);
						break;
				}
				return 0;

			case WM_MOUSEMOVE:
				touch.x = touch.y = touch.z = 0;
				if (GET_Y_LPARAM(lParam)>=touchAreaStart) {
					if (wParam & MK_LBUTTON) {
						touch.x = GET_X_LPARAM(lParam); //+13;
						touch.y = GET_Y_LPARAM(lParam)+16-touchAreaStart;
						touch.z = -1;
						if (isFullscreen) {
							touch.x = (touch.x*256)/fullscreenWidth;
							touch.y = (touch.y*192)/(fullscreenHeight-touchAreaStart);
						}
						if (touch.x<0) touch.x = 0; if (touch.x>255) touch.x = 255;
					}
				}
				return 0;
			case WM_LBUTTONDOWN:
				if (GET_Y_LPARAM(lParam)>=touchAreaStart) {
					SetCapture(hSubScr);
					touch.x = GET_X_LPARAM(lParam); //+13;
					touch.y = GET_Y_LPARAM(lParam)+16-touchAreaStart;
					touch.z = -1;
					if (isFullscreen) {
						touch.x = (touch.x*256)/fullscreenWidth;
						touch.y = (touch.y*192)/(fullscreenHeight-touchAreaStart);
					}
					if (touch.x<0) touch.x = 0; if (touch.x>255) touch.x = 255;
					if (!isFullscreen) {
						wsprintf(szBuffer,"x = %d, y = %d | ipc_x = %d, ipc_y = %d\n",
							touch.x,touch.y,touch.x*14,(touch.y*8917)>>9);
						WriteConsole(hOut,szBuffer,lstrlen(szBuffer),(LPDWORD)&i,NULL);
					}
					if (run)
						mmu_set(TOUCHPAD_DATA,0,1);
				}
				return 0;

			case WM_LBUTTONUP:
				ReleaseCapture();
				touch.x = 0;
				touch.y = 0;
				touch.z = 0;
				if (run)
					mmu_set(TOUCHPAD_DATA,0,0);
				return 0;

			case WM_SIZE:
				return 0;

			case WM_CLOSE:
				SendMessage(hMain,WM_CLOSE,0,0);
				return 0;

		}

	}

	return DefWindowProc(hwnd,uMsg,wParam,lParam);
}



void idle() {
	int i;

	SendMessage(hStatus,SB_SETTEXT,2,(LPARAM)"Idle");
	if (!romLoaded)
		SendMessage(hStatus,SB_SETTEXT,1,(LPARAM)"No ROM loaded");

	while ((!run) && (!quit)) {
		while(PeekMessage(&msg,NULL,0,0,1)) {
			if (!TranslateAccelerator(
					hMain,      // handle to receiving window
					haccel,     // handle to active accelerator table
					&msg))      // message data
			{
				TranslateMessage(&msg);
				DispatchMessage(&msg);
			}
		}

		// Suspend the process for a short while
		if (!quit)
			Sleep(20);
 	}
}



UINT mmTimerID;
void CALLBACK timer_proc(
  UINT uID,      
  UINT uMsg,     
  DWORD dwUser,  
  DWORD dw1,     
  DWORD dw2) {
	int i;
	DWORD dwTick;
	pTransferRegion pIPC;

	if (uID == mmTimerID) {
		dwTick = GetTickCount();
		if (samples)
			cpuEmuSpeed *= (float)perfFreq.QuadPart/(float)(cpu_get(CPU_CYCLE_SCALING)*samples);
		else
			cpuEmuSpeed = 0.0f;
		/*wsprintf(szStat0,"CPU: %d MHz      ",
				(UINT)(cpuEmuSpeed/((float)(dwTick-dwTimerOf)*1000.0f)));*/
		currFps = (UINT)((float)frames*1000.0f / (float)(dwTick-dwTimerOf));
		//wsprintf(&szStat0[16],"GPU: %d fps   ",currFps);
		wsprintf(szStat0,"GPU: %d fps   ",currFps);
		SendMessage(hStatus,SB_SETTEXT,0,(LPARAM)szStat0);
					
		frames = 0;
		cpuEmuSpeed = 0.0f;
		samples = 0;
		dwTimerOf = dwTick;

		GetLocalTime(&systime);

		pIPC = (pTransferRegion)pageTable[0x20];

		// Update IPC time data
		if (false) //ipcLoc)
		{
			mmu_write_dword(0x237F016,((systime.wYear-1744)<<24)|(systime.wMinute<<16)|(systime.wSecond<<8)|(systime.wSecond<<0));
			mmu_write_dword(0x237F01A,(systime.wHour<<24)|(systime.wMonth<<8)|(systime.wDay)|(systime.wSecond<<16));
		} else
		{
			if (romLoaded)
			{
				if (systime.wHour > 11) systime.wHour += 40;
				if (mirrorIPC)
				{
				}
			}
			// Prevent timestamp overflows
			/*if (cycles >= 0x40000000) {
				hub(TELL,ZOMBIE_DEBUG_MSG,"OF on 9",0);
				cpu_set(CPU_CYCLE_COUNT,cycles-0x40000000,0);
				cycles = cpu_get(CPU_CYCLE_COUNT);
					wsprintf(szBuffer,"New cycle count = %d\n", cycles);
						WriteConsole(hOut,szBuffer,lstrlen(szBuffer),(LPDWORD)&dwDummy,NULL);
				for (i=0; i<eq->nItems; i++)
				{
					if (eq->e[i].timestamp >= 0x40000000)
					{
						wsprintf(szBuffer,"adjusting timestamp %d (%d) to %d\n",i,eq->e[i].data,eq->e[i].timestamp-0x40000000);
			WriteConsole(hOut,szBuffer,lstrlen(szBuffer),(unsigned long*)&dwDummy,NULL);
						eq->e[i].timestamp -= 0x40000000;
					}
				}
			}
			if (arm7_cycles >= 0x40000000) {
				hub(TELL,ZOMBIE_DEBUG_MSG,"OF on 7",0);
				cpu_sub_set(CPU_CYCLE_COUNT,arm7_cycles-0x40000000,0);
				arm7_cycles = cpu_sub_get(CPU_CYCLE_COUNT);
				for (i=0; i<eq->nItems; i++)
					if (eq->e[i].timestamp >= 0x40000000)
						eq->e[i].timestamp -= 0x40000000;
			}*/

			if (windows[3].active && run && (palUpdateMode==5))
				InvalidateRect(windows[3].hwnd,NULL,FALSE);
		}
	}
}



void shut_down() {
	timeKillEvent(mmTimerID);

	delete menu;
	delete eq;

	apu_close();
	mmu_close();
	gpu_close();
	inp_close();

	if (aviStreamCreated) //(aviIsRecording)
		avi_stop_recording();

	FreeLibrary(hCPU);
	FreeLibrary(hMMU);
	FreeLibrary(hGPU);
	FreeLibrary(hAPU);
	FreeLibrary(hINP);

	if (romLoaded)
		LocalFree((HLOCAL)cart);

	if (gbacart)
		LocalFree(gbacart);

	DestroyWindow(hSubScr);
	DestroyWindow(hStatus);
	DestroyWindow(hMain);
}



COLORREF RGB2BGR(COLORREF cref) {
	return (cref&0x00FF00)|((cref&0xFF0000)>>16)|((cref&0x0000FF)<<16);
}



/*void list_files(char *path) {
   WIN32_FIND_DATA FindFileData;
   HANDLE hFind = INVALID_HANDLE_VALUE;
   char DirSpec[MAX_PATH + 1];  // directory specification
   char SubDir[MAX_PATH+1];
   DWORD dwError;

   wsprintf(szBuffer,"Target directory is %s.\n", path);
	WriteConsole(hOut,szBuffer,lstrlen(szBuffer),(unsigned long*)&dwDummy,NULL);
	strncpy(DirSpec, path, strlen(path)+1);
   strncat(DirSpec, "\\*", 3);

   hFind = FindFirstFile(DirSpec, &FindFileData);

   if (hFind == INVALID_HANDLE_VALUE) {
      wsprintf(szBuffer,"Invalid file handle. Error is %u\n", GetLastError());
	WriteConsole(hOut,szBuffer,lstrlen(szBuffer),(unsigned long*)&dwDummy,NULL);
      return;
   } else {
      wsprintf(szBuffer,"First file name is %s\n", FindFileData.cFileName);
	WriteConsole(hOut,szBuffer,lstrlen(szBuffer),(unsigned long*)&dwDummy,NULL);
      while (FindNextFile(hFind, &FindFileData) != 0) {
         wsprintf(szBuffer,"Next file name is %s\n", FindFileData.cFileName);
	     WriteConsole(hOut,szBuffer,lstrlen(szBuffer),(unsigned long*)&dwDummy,NULL);
		 if ((FindFileData.dwFileAttributes == FILE_ATTRIBUTE_DIRECTORY)&&
			 (FindFileData.cFileName[0] != '.')) {
			wsprintf(SubDir,"%s\\%s",path,FindFileData.cFileName);
			list_files(SubDir);
		 }
      }
    
      dwError = GetLastError();
      FindClose(hFind);
      if (dwError != ERROR_NO_MORE_FILES) {
         wsprintf(szBuffer,"FindNextFile error. Error is %u\n", dwError);
	WriteConsole(hOut,szBuffer,lstrlen(szBuffer),(unsigned long*)&dwDummy,NULL);
         return;
      }
   }
}*/


// Add an entry to the recent files list //////////////////////////////////////////////

int nRecentFiles = 0;

void add_recent_file(char *szRecentFile) {
	int i;
	if (strlen(szRecentFile)) {
		for (i=0; i<8; i++) {
			if (strcmp(recentFiles[i],szRecentFile)==0)
				return;
			else if (strlen(recentFiles[i])==0)
				break;
		}
		if (i<8) {
			sprintf(szStat1,"%d.  %s",i+1,szRecentFile);
			recentFilesMenu->add_item(szStat1,IDM_RECENT1+i,true);
			strcpy(recentFiles[i],szRecentFile);
		}
		if (i==8) {
			i = nRecentFiles;
			sprintf(szStat1,"%d.  %s",i+1,szRecentFile);
			strcpy(recentFiles[i],szRecentFile);
			ModifyMenu(recentFilesMenu->hMenu,i,MF_BYPOSITION|MF_STRING,i+IDM_RECENT1,szStat1);
		}
		if (hMain!=NULL)
			DrawMenuBar(hMain);
		sprintf(szStat1,"Recent%d",i+1);
		WritePrivateProfileString("Recent",szStat1,szRecentFile,iniFn);
		nRecentFiles = (nRecentFiles+1)&7;
	}
}

///////////////////////////////////////////////////////////////////////////////////////
		 

int APIENTRY WinMain(HINSTANCE hInstance,HINSTANCE hPrevInstance,LPSTR lpCmdLine,int nCmdShow)
{
	int		i,j,k;
	RECT	rect,rect3;
	HWND	hWnd;
	HMENU	hSysMenu;
	char	*szCommandline;
	static const char delimit = ' ';
	char	*token,*p1,*p2;
	char	*romName,*romName2;

	hInst = hInstance;

	romName = new char[512];
	romName2 = romName;
	strncpy(romName,lpCmdLine,512);

	szPath = (char*)get_path();
	GetCurrentDirectory(256,currDir);

	eq = new CEventQueue(192);

	wsprintf(szScrFn,"%s\\dualis.bmp",szPath);
	wsprintf(szAviFn,"c:\\dualis.avi");
	avigen.SetFileName(_T(szAviFn));

	wsprintf(iniFn,"%s\\dualis.ini",szPath);
	fpsLimit  = GetPrivateProfileInt("GPU","LimitFPS",1,iniFn);
	frameskip = GetPrivateProfileInt("GPU","Frameskip",0,iniFn);
	renderer  = GetPrivateProfileString("GPU","Renderer","OpenGL",szBuffer,32,iniFn);
	if (strcmp("D3D",szBuffer)==0)
		renderer = 1;
	else if (strcmp("GDI",szBuffer)==0)
		renderer = 2;
	else
		renderer = 0;

	fullscreenWidth  = GetPrivateProfileInt("GPU","FullscreenWidth",640,iniFn);
	fullscreenHeight = GetPrivateProfileInt("GPU","FullscreenHeight",480,iniFn);
	for (i=0; i<4; i++) {
		if ((fullscreenWidth==validModes[i][0])&&(fullscreenHeight==validModes[i][1]))
			break;
	}
	if (i==4) { fullscreenWidth = 640; fullscreenHeight = 480; }


	cfDevice  = GetPrivateProfileInt("CompactFlash","DeviceType",1,iniFn);

	soundMasterEnable = GetPrivateProfileInt("APU","EmulateSound",1,iniFn);
	largeSoundBuffer  = GetPrivateProfileInt("APU","LargeSoundBuffer",0,iniFn);

	sampleRate        = GetPrivateProfileInt("APU","SampleRate",32000,iniFn);
	if ((sampleRate!=22050)&&(sampleRate!=32000)&&(sampleRate!=44100))
		sampleRate = 32000;

	ipcFormat = GetPrivateProfileInt("IPC","DefaultIPCVersion",1,iniFn);
	tsCalibX1 = GetPrivateProfileInt("Calibration","x1",0,iniFn);
	tsCalibY1 = GetPrivateProfileInt("Calibration","y1",0,iniFn);
	tsCalibX2 = GetPrivateProfileInt("Calibration","x2",0,iniFn);
	tsCalibY2 = GetPrivateProfileInt("Calibration","y2",0,iniFn);

	openCon = false;

	//strcpy(szBuffer,lpCmdLine);
	if (strlen(lpCmdLine)) {
		token = strtok(lpCmdLine,&delimit);
		while (token != NULL) {
			if (token != NULL) {}
			if (strcmp("-theme",token)==0) {
				token = strtok(NULL,&delimit);
				if (token==NULL) break;
				theme = atoi(token);
			} else if (strcmp("-wincon",token)==0) {
				openCon = true;
			}

			token = strtok(NULL,&delimit);
		}
	}

	p1 = strchr(romName,'\"');
	if (p1==NULL) p1 = romName+10000;
	while (strchr(romName,' ')) {
		p2=strchr(romName,' ')+1;
		if (p2>p1) break;
		romName = p2;
	}

	keymap[KEY_UP] = GetPrivateProfileInt("Keys","KeyUp",38,iniFn);
	keymap[KEY_DOWN] = GetPrivateProfileInt("Keys","KeyDown",40,iniFn);
	keymap[KEY_LEFT] = GetPrivateProfileInt("Keys","KeyLeft",37,iniFn);
	keymap[KEY_RIGHT] = GetPrivateProfileInt("Keys","KeyRight",39,iniFn);
	keymap[KEY_A] = GetPrivateProfileInt("Keys","KeyA",88,iniFn);
	keymap[KEY_B] = GetPrivateProfileInt("Keys","KeyB",90,iniFn);
	keymap[KEY_X] = GetPrivateProfileInt("Keys","KeyX",65,iniFn);
	keymap[KEY_Y] = GetPrivateProfileInt("Keys","KeyY",83,iniFn);
	keymap[KEY_L] = GetPrivateProfileInt("Keys","KeyL",76,iniFn);
	keymap[KEY_R] = GetPrivateProfileInt("Keys","KeyR",82,iniFn);
	keymap[KEY_START] = GetPrivateProfileInt("Keys","KeyStart",13,iniFn);
	keymap[KEY_SELECT] = GetPrivateProfileInt("Keys","KeySelect",32,iniFn);

	windows[0].active = false;
	windows[1].active = false;
	windows[2].active = false;
	windows[3].active = false;
	windows[4].active = false;
	windows[5].active = false;
	windows[6].active = false;
	hMain = NULL;

	windows[0].hwnd = hMain = create_window("Dualis","DualisClass",NULL,NULL,COLOR_BTNFACE,440,288+16,(WNDPROC)wnd_proc);
	//windows[1].hwnd = hMainScr = create_window("Main screen","MnScrClass",NULL,NULL,COLOR_MENUTEXT,240+8,160+28,(WNDPROC)wnd_proc);
	//windows[2].hwnd = hSubScr = CreateDialog(hInst,MAKEINTRESOURCE(IDD_DIALOG14),hMain,(DLGPROC)DlgProc14); //create_window("Video output","SbScrClass",NULL,MAKEINTRESOURCE(IDI_ICON2),COLOR_MENUTEXT,240+8,160+28,(WNDPROC)wnd_proc);
	windows[2].hwnd = hSubScr = create_window("Video output","SbScrClass",NULL,MAKEINTRESOURCE(IDI_ICON2),COLOR_MENUTEXT,240+8,160+28,(WNDPROC)wnd_proc);

	windows[0].active = true;
	windows[2].active = true;

	menu = new CMenu;

	defaultFontID = (UINT)GetStockObject(ANSI_VAR_FONT);

	// Create a font
    font = CreateFont(11,0,0,0,
					FW_NORMAL,	// Specify normal font weight
    			    0,			// Italic flag
    			    0,
    			    0,
        	        ANSI_CHARSET,
        	        OUT_OUTLINE_PRECIS,
        	        CLIP_DEFAULT_PRECIS,
        	        ANTIALIASED_QUALITY,
        	        FF_DONTCARE,
        	        "lucida console");

////////////////////////// Set up the debug console window ///////////////////////////////////


	SelectObject(dbgdc, font);
	SetBkColor(dbgdc,GetSysColor(COLOR_MENU));
	SetTextColor(dbgdc,RGB(132,32,32));

    hScrollbar1 = CreateWindowEx(0L,
                   "SCROLLBAR",
                   NULL, // There is no text to display
                   WS_CHILD | WS_VISIBLE | SBS_VERT,
                   296,
                   0,
                   16,
                   172,
                   hDbgw,
                   NULL,
                   hInst,
                   NULL);

        ZeroMemory(&si, sizeof(si));
        si.cbSize = sizeof(si);
        si.fMask  = SIF_RANGE | SIF_PAGE | SIF_POS;
        si.nMin   = 0;
        si.nMax   = 0;
        si.nPage  = 1;
        si.nPos   = 0;
        SetScrollInfo(hScrollbar1, SB_CTL, &si, TRUE);


////////////////////////////////////////////////////////////////////////////////////////////////

	InitCommonControls();

	menu->add_popup("File");
		menu->last->add_item("Load and execute..\tCtrl+R",IDM_LOAD_AND_EXEC,true);
		menu->last->add_popup("Execute recent");
		recentFilesMenu = menu->last->popup;
			//menu->last->popup->add_item("Main screen\tCtrl+1",IDM_SCREEN_MAIN,true);
		
		menu->last->add_item("Load..\tCtrl+L",IDM_LOAD,true);
		menu->last->add_item("ROM info..",IDM_ROM_INFO,false);
		menu->last->add_item("Close",IDM_CLOSE,true);
		menu->last->add_item(0,0,false);
		menu->last->add_popup("Save screenshot");
			menu->last->popup->add_item("Main screen\tCtrl+1",IDM_SCREEN_MAIN,true);
			menu->last->popup->add_item("Sub screen\tCtrl+2",IDM_SCREEN_SUB,true);
			menu->last->popup->add_item("Both screens\tCtrl+3",IDM_SCREEN_BOTH,true);

		menu->last->add_popup("Movie");
			menu->last->popup->add_item("Start recording\t,",IDM_MOVIE_START,true);
			menu->last->popup->add_item("Stop recording\t.",IDM_MOVIE_STOP,true);
			menu->last->popup->add_item("Setup..\tCtrl+V",IDM_MOVIE_SETUP,true);

		menu->last->add_item(0,0,false);
		menu->last->add_item("Exit\tEsc",IDM_EXIT,true);

	menu->add_popup("Emulation");
		menu->last->add_item("Run\tF5",IDM_RUN,true);
		menu->last->add_item("Pause\tF6",IDM_PAUSE,true);
		menu->last->add_item("Reset\tF7",IDM_RESET,true);

	menu->add_popup("View");
		menu->last->add_item("Disassembler..\tCtrl+D",IDM_DISASM,true);
		menu->last->add_item("Memory..\tCtrl+M",IDM_MEMORY,true);
		menu->last->add_item("ARM9 I/O registers..\tCtrl+I",IDM_IOREGS,true);
		menu->last->add_item("ARM7 I/O registers..\tCtrl+Shift+I",IDM_IOREGS7,true);
		menu->last->add_item("Palette..\tCtrl+P",IDM_PALETTE,true);
		menu->last->add_item("Tiles..\tCtrl+T",IDM_TILES,true);
		menu->last->add_item("Map..\tCtrl+A",IDM_MAP,true);
		menu->last->add_item("OAM..\tCtrl+O",IDM_OAM,true);
		menu->last->add_item("Textures..\tCtrl+X",IDM_TEXTURE,true);
		//menu->last->add_item("3D unit..\tCtrl+Z",IDM_MATRIX,true);
		menu->last->add_item("Debug console..\tCtrl+C",IDM_DBGCON,true);

	menu->add_popup("Help");
		menu->last->add_item("About..",IDM_ABOUT,true);

	SetMenu(hMain,menu->hMenu);

	hPropsheet = create_propsheet();
	if(hPropsheet == INVALID_HANDLE_VALUE) {
		WINERROR("Property sheet creation failed.");
		ExitProcess(0);
	}

	SetWindowLong(hPropsheet, GWL_STYLE, WS_CHILD);
	SetParent(hPropsheet,hMain);
	SetWindowLong(hPropsheet, GWL_EXSTYLE, WS_EX_CONTROLPARENT);

	init_propsheet_size();

	SetTimer(hMain, 777, 1200, NULL);
	mmTimerID = (UINT)timeSetEvent(1000,10,timer_proc,NULL,TIME_PERIODIC);
	dwTimerOf = GetTickCount();

	DragAcceptFiles(hMain,TRUE);

	hStatus = CreateStatusWindow(WS_CHILD|WS_VISIBLE,"",hMain,1555);

	ShowWindow(hMain,SW_SHOW);
	ShowWindow(hSubScr,SW_SHOW);

	GetWindowRect(hMain,&rect);
	force_window_size(hSubScr,rect.right+24,rect.top,256,384);


	UpdateWindow(hSubScr);
	UpdateWindow(hMain);


    hSysMenu = GetSystemMenu(hSubScr, 0);
	EnableMenuItem(hSysMenu, SC_CLOSE, (MF_BYCOMMAND|MF_GRAYED));


	bmp_config(BMP_FLIP, BMP_DONT_FLIP);
	bmp_config(BMP_HEADER, BMP_HEADER);
	bmp_config(BMP_PALETTE, BMP_PALETTE);
	bmp_config(BMP_ALIGN, BMP_ALIGN);


	init();


	// Try to load a rom if one was specified on the commandline
	if (strlen(lpCmdLine)) {
		// Handle quoted filenames from explorer
		if (romName[0] == '\"')	{
			romName[strlen(romName)-1] = '\0';
			romName++;
			strcpy(szBuffer3,romName);
			for (i=strlen(romName)-1; i>0; i--)
				if (romName[i]=='\\') break;
			strncpy(szRomPath,romName,i);
			szRomPath[i+1] = '\0';
			}
		else if (!((strchr(romName,':')!=NULL) || (romName[0]=='\\'))) {
			wsprintf(szBuffer3,"%s\\%s",currDir,romName);
			strcpy(szRomPath,currDir);
		} else {
			strcpy(szBuffer3,romName);
			for (i=strlen(romName)-1; i>0; i--)
				if (romName[i]=='\\') break;
			strncpy(szRomPath,romName,i);
			szRomPath[i+1] = '\0';
		}
		//MessageBox(NULL,szRomPath,"fubar",MB_OK);
		cart = load_rom(szBuffer3);
		if (cart) {
			SendMessage(hStatus,SB_SETTEXT,1,(LPARAM)romName);
			wsprintf(szBuffer,"Loaded ROM: %s",romName);
			hub(TELL,ZOMBIE_DEBUG_MSG,szBuffer,0);
			romLoaded = true;
			reset_machine(true);
			run = true;
		} else	{
			SendMessage(hStatus,SB_SETTEXT,1,(LPARAM)"No ROM loaded");
			run = false;
		}
	}

	colors[0] = GetPrivateProfileInt("Colors","ColorBackground",0xFFFFFF,iniFn);
	colors[1] = GetPrivateProfileInt("Colors","ColorAddress",0x909090,iniFn);
	colors[2] = GetPrivateProfileInt("Colors","ColorMnemonic",0x0000FF,iniFn);
	colors[3] = GetPrivateProfileInt("Colors","ColorRegister",0x000090,iniFn);
	colors[4] = GetPrivateProfileInt("Colors","ColorImmediate",0x808010,iniFn);
	colors[5] = GetPrivateProfileInt("Colors","ColorComment",0x009000,iniFn);
	colors[6] = GetPrivateProfileInt("Colors","ColorBracket",0xFF0000,iniFn);
	colors[7] = GetPrivateProfileInt("Colors","ColorText",0x000000,iniFn);

	for (i=0; i<8; i++)
		colors[i] = RGB2BGR(colors[i]);

	haccel = LoadAccelerators(hInst,(LPCSTR)MAKEINTRESOURCE(IDR_ACCELERATOR1));

	GetPrivateProfileString("Recent","Recent1","",szBuffer,MAX_PATH,iniFn);
	add_recent_file(szBuffer);
	GetPrivateProfileString("Recent","Recent2","",szBuffer,MAX_PATH,iniFn);
	add_recent_file(szBuffer);
	GetPrivateProfileString("Recent","Recent3","",szBuffer,MAX_PATH,iniFn);
	add_recent_file(szBuffer);
	GetPrivateProfileString("Recent","Recent4","",szBuffer,MAX_PATH,iniFn);
	add_recent_file(szBuffer);
	GetPrivateProfileString("Recent","Recent5","",szBuffer,MAX_PATH,iniFn);
	add_recent_file(szBuffer);
	GetPrivateProfileString("Recent","Recent6","",szBuffer,MAX_PATH,iniFn);
	add_recent_file(szBuffer);
	GetPrivateProfileString("Recent","Recent7","",szBuffer,MAX_PATH,iniFn);
	add_recent_file(szBuffer);
	GetPrivateProfileString("Recent","Recent8","",szBuffer,MAX_PATH,iniFn);
	add_recent_file(szBuffer);


	while (!quit) {
		idle();
		emulate();
	}

	shut_down();
	delete[] romName2;

	return msg.wParam;
}
